ostream& operator<< (ostream& o, const VisualInfo& vi)
{
	Value ed ;
	Value rdist_change ;
	Angle rdir_change ;
	char tmp[128] ;

	ed = Quantize(exp(Quantize(log(vi.distance + EPS),vi.qstep)),0.1) ;

	sscanf(vi.name,"(%s",tmp) ;
	//*************************************************************************
	// Player
	//*************************************************************************
	if (!strcmp(tmp,"player")) {
		double prob ;
		prob = (ed-TEAM_FAR_LENGTH)/(TEAM_TOOFAR_LENGTH-TEAM_FAR_LENGTH) ;
		if (prob>drand(0,1)) {
		  o << "(" << ((Player *)(vi.object))->short_name_toofar << " " ;
		  if (vi.highquality)
			o << ed << " " ; 
		  return o << Rad2IDegRound(vi.direction) << ")" ;
		}

		prob = (ed-UNUM_FAR_LENGTH)/(UNUM_TOOFAR_LENGTH-UNUM_FAR_LENGTH) ;
		if (prob>drand(0,1)) {
		  o << "(" << ((Player *)(vi.object))->short_name_far << " " ;
		  if (vi.highquality)
			o << ed << " " ;
		  return o << Rad2IDegRound(vi.direction) << ")" ;
		}
		
		o << "(" << vi.short_name << " " ;

		if (vi.highquality) {
			o << ed << " " ;
			if (vi.distance != Zero)
				rdist_change = ed * Quantize(vi.dist_change/vi.distance, 0.02) ;
			else
				rdist_change = Zero ;
			if (vi.dir_change != Zero)
				rdir_change = Quantize(vi.dir_change,vi.qstep_dir) ;
			else
				rdir_change = Zero ;

			return o << Rad2IDegRound(vi.direction) << " "
				 << rdist_change << " "
				 << rdir_change << " "
				 << Rad2IDegRound(vi.body_dir) << " "
				 << Rad2IDegRound(vi.face_dir) << ")" ;
		}
		else
			return o << Rad2IDegRound(vi.direction) << ")" ;
	}
	//*************************************************************************
	// Line
	//*************************************************************************
	else if (!strcmp(tmp, "line")) {
	  o << "(" << vi.short_name << " " ;
	  if (vi.highquality)
		o << ed << " " ;
	  return o << Rad2IDegRound(vi.direction) << ")" ;
	}
	//*************************************************************************
	// Ball || Flag
	//*************************************************************************
	else if (!strcmp(tmp, "ball)") || !strcmp(tmp, "flag")) {
		double prob ;
		prob = (ed-UNUM_FAR_LENGTH)/(UNUM_TOOFAR_LENGTH-UNUM_FAR_LENGTH) ;
		if (prob>drand(0,1)) {
		  o << "(" << vi.short_name << " " ;
		  if (vi.highquality)
		    o << ed << " " ;
		  return o << Rad2IDegRound(vi.direction) << ")" ;
		}
	}
	else {		/* near object that can't see */
	  o << "(" << vi.short_name << " " ;
	  if (vi.highquality)
	    o << ed << " " ;
	  return o << Rad2IDegRound(vi.direction) << ")" ;
	}

	o << "(" << vi.short_name << " " ;
	
	if (vi.highquality) {
		o << ed << " " ;
		if (vi.distance != Zero)
			rdist_change = ed * Quantize(vi.dist_change/vi.distance, 0.02) ;
		else
			rdist_change = Zero ;
		if (vi.dir_change != Zero)
			rdir_change = Quantize(vi.dir_change, vi.qstep_dir) ;
		else
			rdir_change = Zero ;
		return o << Rad2IDegRound(vi.direction) << " "
			 << rdist_change << " " << rdir_change << ")" ;
	}
	else
		return o << Rad2IDegRound(vi.direction) << ")" ;
}
