//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	BSkillList.cpp
 *  \brief	Implementacia zoznamu naplanovanych 
 *  \brief	zakladnych schopnosti
 *  \author Rado Otipka 
 *  \date 4. 12. 2001 21:49:11
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CBasicSkillList::CBasicSkillList() 
{
}

CBasicSkillList::~CBasicSkillList() 
{
	Empty();
}

//------------------------------------------------------
/*! \fn	void CBasicSkillList::EvaluateAndRemove() 
 *  \brief Vyhodnoti zakladnu schopnost s najvysou prioritou
 *  \return
 *  \author Rado Otipka
 *  \date 3. 12. 2001 20:20:22

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CBasicSkillList::EvaluateAndRemove() 
{
	CBasicSkill *pBSkill;

	if(IsEmpty())
		return KPDL_ERROR;

	// spracovanie naplanovanej schopnosti s najvyssou prioritou
	// okrem otocenia hlavy, zmeny kvality pohladu a povedania spravy
	// (ktore sa v 1 cykle mozu naplanovat paralelne)

	int iMaxPriority = BSKILL_INVALID_PRIORITY;
	TBasicSkillVectorIterator pIter = m_cSkills.begin();
	TBasicSkillVectorIterator pLast = m_cSkills.end();
	TBasicSkillVectorIterator pFound = NULL;

	for(; pIter != pLast; pIter ++)
	{
		if(!(*pIter)->IsTypeOf(BSKILL_TURN_NECK) && 
			!(*pIter)->IsTypeOf(BSKILL_CHANGEVIEW) &&
			!(*pIter)->IsTypeOf(BSKILL_SAY) &&
			(*pIter)->iPriority > iMaxPriority
		)
		{
			iMaxPriority = (*pIter)->iPriority;
			pFound = pIter;
		}
	}

	if(pFound != NULL)
	{
		if((*pFound)->iType == BSKILL_MANAGE_REMOVEALL)
		{
			return Empty();
		}
//		else if((*pFound)->IsTypeOf(BSKILL_MANAGE))
//			tu by sa spracovali ostatne manage skills !!!
		else 
		{
			pBSkill = *pFound;
			m_cSkills.erase(pFound);

			if(pBSkill->Execute() != KPDL_UNSUCCESS)
			{
				delete pBSkill;
			}
			else
			{
				m_cSkills.insert( m_cSkills.begin(), pBSkill );
			}
		}
	}

	// spracovanie naplanovanej schopnosti otocenia hlavy
	// s najvyssou prioritou
	iMaxPriority = BSKILL_INVALID_PRIORITY;
	pFound = NULL;
	for(pIter = m_cSkills.begin(); pIter != pLast; pIter ++)
	{
		if((*pIter)->IsTypeOf(BSKILL_TURN_NECK) && 
			(*pIter)->iPriority > iMaxPriority
		)
		{
			iMaxPriority = (*pIter)->iPriority;
			pFound = pIter;
		}
	}

	if(pFound != NULL)
	{
		pBSkill = *pFound;
		m_cSkills.erase(pFound);

		if(pBSkill->Execute() != KPDL_UNSUCCESS)
		{
			delete pBSkill;
		}
		else
		{
			m_cSkills.insert( m_cSkills.begin(), pBSkill );
		}
	}

	// spracovanie naplanovanej schopnosti zmeny kvality pohladu
	// s najvyssou prioritou
	iMaxPriority = BSKILL_INVALID_PRIORITY;
	pFound = NULL;
	for(pIter = m_cSkills.begin(); pIter != pLast; pIter ++)
	{
		if((*pIter)->IsTypeOf(BSKILL_CHANGEVIEW) && 
			(*pIter)->iPriority > iMaxPriority
		)
		{
			iMaxPriority = (*pIter)->iPriority;
			pFound = pIter;
		}
	}

	if(pFound != NULL)
	{
		pBSkill = *pFound;
		m_cSkills.erase(pFound);

		if(pBSkill->Execute() != KPDL_UNSUCCESS)
		{
			delete pBSkill;
		}
		else
		{
			m_cSkills.insert( m_cSkills.begin(), pBSkill );
		}
	}

	// spracovanie naplanovanej schopnosti povedania spravy
	// s najvyssou prioritou
	iMaxPriority = BSKILL_INVALID_PRIORITY;
	pFound = NULL;
	for(pIter = m_cSkills.begin(); pIter != pLast; pIter ++)
	{
		if((*pIter)->IsTypeOf(BSKILL_SAY) && 
			(*pIter)->iPriority > iMaxPriority
		)
		{
			iMaxPriority = (*pIter)->iPriority;
			pFound = pIter;
		}
	}

	if(pFound != NULL)
	{
		pBSkill = *pFound;
		m_cSkills.erase(pFound);

		if(pBSkill->Execute() != KPDL_UNSUCCESS)
		{
			delete pBSkill;
		}
		else
		{
			m_cSkills.insert( m_cSkills.begin(), pBSkill );
		}
	}

	return KPDL_SUCCESS;
}

//------------------------------------------------------
/*! \fn	KPDL_RESULT CBasicSkillList::Empty() 
 *  \brief vyprazdni zoznam naplanovanych schopnosti
 *  \return
 *  \author Radoslav Otipka 
 *  \date 2.5.2002 9:44:39

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CBasicSkillList::Empty() 
{
	TBasicSkillVectorIterator pIter = m_cSkills.begin();
	TBasicSkillVectorIterator pLast = m_cSkills.end();

	for(; pIter != pLast; pIter ++)
	{
 		delete *pIter;
	}
	m_cSkills.clear();

	return KPDL_SUCCESS;
}

//------------------------------------------------------
/*! \fn	KPDL_RESULT CBasicSkillList::GetFirst(CBasicSkill **cSkill)
 *  \brief vrati prvu naplanovanu zakl. schopnost
 *  \param CBasicSkill **cSkil
 *  \return
 *  \author Radoslav Otipka 
 *  \date 2.5.2002 9:45:03

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CBasicSkillList::GetFirst(CBasicSkill **cSkill)
{ 
	if(IsEmpty())
		return KPDL_ERROR;
	
	int iMaxPriority = BSKILL_INVALID_PRIORITY;
	TBasicSkillVectorIterator pIter = m_cSkills.begin();
	TBasicSkillVectorIterator pLast = m_cSkills.end();
	TBasicSkillVectorIterator pFound = NULL;


	for(; pIter != pLast; pIter ++)
	{
		if(!(*pIter)->IsTypeOf(BSKILL_TURN_NECK) && 
			!(*pIter)->IsTypeOf(BSKILL_CHANGEVIEW) &&
			!(*pIter)->IsTypeOf(BSKILL_SAY) &&
			(*pIter)->iPriority > iMaxPriority
		)
		{
			iMaxPriority = (*pIter)->iPriority;
			pFound = pIter;
		}
	}

	if(pFound == NULL)
	{
		return KPDL_ERROR;
	}
	
	*cSkill = *(pFound);
	return KPDL_SUCCESS;
}
