#ifndef _BAS_SKIL_MAIN_
#define _BAS_SKIL_MAIN_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#pragma warning (disable:4786)

/////////////////////////////////////////////////////////////////////
// External libraries
#include "worldmain.h"

/////////////////////////////////////////////////////////////////////
// Platform dependent header files
#define VC_EXTRALEAN
#include <afx.h>
#include <afxwin.h>

/////////////////////////////////////////////////////////////////////
// Standard header files
#include <string>
#include <vector>

using namespace std;

/////////////////////////////////////////////////////////////////////
// Library settings

// Konfiguracia zakladnych schopnosti
#define BSKILL_SUBTYPE_LIMIT          100

#define BSKILL_NO_TYPE                0

#define BSKILL_KICK			          100     
#define BSKILL_KICK_WITH_POWER        101 //smer - double, sila kopu - double 
#define BSKILL_KICK_WITH_ACCEL        102 //smer - double, akceleracia(zrychlenie) - double 
#define BSKILL_KICK_WITH_ACCEL_BYPASS 103 // pozicia -  C2DVector, akceleracia(zrychlenie) - double //taky kop aby som netrafil hraca v smere kopu
#define BSKILL_KICK_TO_POSITION       104 //  pozicia - C2DVector, akceleracia(zrychlenie) -double
#define BSKILL_KICK_GOAL              105 //bez parametra
#define BSKILL_KICK_FRIENDKICK        106 //bez parametra, to ktoremu spoluhracovi ma nahrat, si vypocita sam
#define BSKILL_KICK_STOPBALL          107
#define BSKILL_KICK_PASS_INTERCEPT	  108	          
	
#define BSKILL_MOVE                   200
#define BSKILL_MOVE_DASH              201 //power - double// elementarny pohyb vpred
#define BSKILL_MOVE_GOTO              202 //pozicia - C2DVector , zrychlenie - double 
#define BSKILL_MOVE_FACETOGO          203 //pohybujuci sa objekt - CMovingObject *, pozicia(kam sa ma hrac dostat) - C2DVector, zrychlenie -double//beh na urcenu poziciu, pricom sa pozeram, stale na urcity objekt 
#define BSKILL_MOVE_TO                204 //pozicia - C2DVector alebo suradnice x,y //hrac sa nastvy na urcenu, poziciu 
#define BSKILL_MOVE_GOTO_PLAYER       205 //chod k hracovi
#define BSKILL_MOVE_GOTO_BALL         206

#define BSKILL_TURN	                  300 
#define BSKILL_TURN_ME                301 //moment - double
#define BSKILL_TURN_TO	              302 //pozicia - C2DVector
#define BSKILL_TURN_2                 303 //uhol otocenia - double 
#define BSKILL_TURN_TO_BALL			  304 	

#define BSKILL_CATCH                  400
#define BSKILL_CATCH_BASIC            401 //direction(smer) - double

#define BSKILL_DRIBBLE                500
#define BSKILL_DRIBLE_SMART           501 //pozicia - C2DVector, zrychlenie - double

#define BSKILL_MANAGE                 600
#define BSKILL_MANAGE_REMOVEALL       601 //bez parametrov, vymaze vsetky prvky v zoznam schopnosti

#define BSKILL_TURN_NECK              700
#define BSKILL_TURN_NECK_BASIC        701 //moment - double
#define BSKILL_TURN_NECK_TO           702 //pozicia - C2DVector
#define BSKILL_TURN_NECK_STRAIGHT     703 //bez parametrov//otocenie hlavy dopredu
#define BSKILL_TURN_NECK_TO_BALL      704 //bez parametrov//otocenie sa za loptou

#define BSKILL_PASS                   800  
#define BSKILL_PASS_TO                801

#define BSKILL_SAY                    900
#define BSKILL_SAY_IT                 901

#define BSKILL_CHANGEVIEW             1000
#define BSKILL_CHANGEVIEW_NOW         1001

/* parametre uvedene v hranatych zatvorkach nie je povinne uvadzat
1. Kop na poziciu, CKick, VALUE_TYPE = BSKILL_KICK_TO_POSITION, VALUE_X = x, VALUE_Y = y, [VALUE_ACCEL = zrychlenie]
2. Chod na poziciu, CMove, VALUE_TYPE = BSKILL_MOVE_GOTO, VALUE_X = x, VALUE_Y = y, [VALUE_ACCEL = zrychlenie]
3. Chod k hracovi, CMove, VALUE_TYPE = BSKILL_MOVE_GOTO_PLAYER, VALUE_PLAYER = cislo hraca
4. Prihraj hracovi, CPass, VALUE_TYPE = BSKILL_PASS_TO, VALUE_PLAYER = cislo hraca
5. Dribluj na poziciu, CDrible, VALUE_TYPE = BSKILL_DRIBLE_SMART, VALUE_X = x, VALUE_Y = y, [VALUE_ACCEL = zrychlenie]
6. Chyt loptu do ruk, CCatch, VALUE_TYPE = BSKILL_CATCH_BASIC, VALUE_X = x_poziciaLopty, VALUE_Y = y_poziciaLopty
7. Otoc sa na poziciu, CTurn, VALUE_TYPE = BSKILL_TURN_TO, VALUE_X = x, VALUE_Y = y
8. Otoc krk na poziciu, CTurnNeck, VALUE_TYPE = BSKILL_TURN_NECK_TO, VALUE_X = x, VALUE_Y = y
*/

// Deklaracia tvaru jednotlivych parametrov pre dualny interface
#define BSKILL_PARAM_TYPE             "type"
#define BSKILL_PARAM_X                "x"
#define BSKILL_PARAM_Y	              "y"
#define BSKILL_PARAM_ACCEL            "accel"
#define BSKILL_PARAM_ANGLE            "angle"
#define BSKILL_PARAM_WIDTH            "wide"
#define BSKILL_PARAM_QUALITY          "resolution"
#define BSKILL_PARAM_SAYSTRING        "saystring"
#define BSKILL_PARAM_PLAYER           "player"
#define BSKILL_PARAM_MOMENT           "moment"
#define BSKILL_PARAM_POWER			  "power"	
#define BSKILL_PARAM_EFFORT			  "effort"

// Priority
#define BSKILL_INVALID_PRIORITY       -1
#define BSKILL_DEFAULT_PRIORITY       100
#define BSKILL_NO_PRIORITY			   0
#define BSKILL_MAX_PRIORITY			  101
//
#define MAX_DISTANCE                  999999.99
#define MIN_DIST                      1.2
#define MAXNTESTDIR                   16
//
#define MAX_EFFORT_ATRIB			  0.01

#define NECKRANGE(x) \
	(((x) > gpConfig->maxneckmoment)? gpConfig->maxneckmoment : \
    (((x) < gpConfig->minneckmoment)? gpConfig->minneckmoment : (x)))

#define POWERRANGE(x) \
	(((x) > gpConfig->maxpower)? gpConfig->maxpower : \
	(((x) < gpConfig->minpower)? gpConfig->minpower : (x)))

#define MOMENTRANGE(x) \
	(((x) > gpConfig->maxmoment)? gpConfig->maxmoment : \
	(((x) < gpConfig->minmoment)? gpConfig->minmoment : (x)))

#define MINTURN  0.001

enum EEffort {
	EFF_Minimum,
	EFF_Medium,
	EFF_Maximum
};

// Pass angles
#define MAX_PASS_ANGLE 13
#define MIN_PASS_ANGLE  6
#define MAX_SAY_STRING_SIZE 512

/////////////////////////////////////////////////////////////////////
// Library header files
#include "types.h"
#include "config.h"
#include "skillparameter.h"
#include "estimatesituation.h"
#include "basicskill.h"
#include "bskilllist.h"
#include "catch.h"
#include "changeview.h"
#include "dribble.h"
#include "kick.h"
#include "manage.h"
#include "move.h"
#include "pass.h"
#include "say.h"
#include "turn.h"
#include "turnneck.h"
/////////////////////////////////////////////////////////////////////
// Global objects

#endif // _BAS_SKIL_MAIN_