//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	Catch.cpp
 *  \brief	zakladna schopnost chytania lopty - pre brankara
 *  \author Rado Otipka 
 *  \date 4. 12. 2001 21:49:11
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//------------------------------------------------------
/*! \fn	CCatch::CCatch(TSkillParameterVector &cParameters, 
	const int iPriority,   
	CWorldModel &cWorld,
	CGameCommandSeq &cActions
	)
 *  \brief Konstruktor
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:27:27

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
CCatch::CCatch(
	TSkillParameterVector &cParameters, 
	const int iPriority,
	CWorldModel &cWorld,
	CGameCommandSeq &cActions
)
:	CBasicSkill(cParameters, BSKILL_CATCH, iPriority, cWorld, cActions) 
{
	//! t0t0 je mozno zbytocne
	m_dAcceleration = 0.0;
}

//------------------------------------------------------
/*! \fn	CCatch::CCatch	const int iCatchType,
	const int iPriority,
	CWorldModel &cWorld,
	CGameCommandSeq &cActions
	)
 *  \brief Konstruktor
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:27:03

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
CCatch::CCatch(
	const int iCatchType,
	const int iPriority,
	CWorldModel &cWorld,
	CGameCommandSeq &cActions
)
:	CBasicSkill(iCatchType, iPriority, cWorld, cActions)
{
}

BEGIN_SKILL_MAP(CCatch)
	ADD_SKILL(BSKILL_CATCH_BASIC, Catch)
END_SKILL_MAP

//------------------------------------------------------
/*! \fn	void CCatch::Catch()
 *  \brief chytenie lopty brankarom
 *  \param  double dir
 *  \return
 *  \author Rado Otipka
 *  \date 3. 12. 2001 20:21:49

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CCatch::Catch()
{
	// ! RadToDeg - asi to tu zrusime :(
	if(m_cSituation.BallCatchable())
	{
		C2DVector cToBall = m_cWorld.cThis.RelVectorTo(m_cPosition);
		CGameCommand *pGameCommand = new CGameCommand();
		pGameCommand->Catch((AngNormalise(cToBall.GetAngle())));
		m_cActions.AddGameCommand(pGameCommand);
		return KPDL_SUCCESS;
	}
	return KPDL_UNSUCCESS;
}
