//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	ChangeView.cpp
 *  \brief	zakladna schopnost zmeny kvality a uhla pohladu
 *  \author Rado Otipka 
 *  \date 4. 12. 2001 21:49:11
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//------------------------------------------------------
/*! \fn	CChangeView::CChangeView(
	TSkillParameterVector &cParameter, 
	const int iPriority,
	CWorldModel &cWorld, 
	CGameCommandSeq &cActions
)
 *  \brief Konstruktor
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:29:49

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
CChangeView::CChangeView(
	TSkillParameterVector &cParameter, 
	const int iPriority,
	CWorldModel &cWorld, 
	CGameCommandSeq &cActions
)
:	CBasicSkill(cParameter, BSKILL_MOVE, iPriority, cWorld, cActions) 
{
}

BEGIN_SKILL_MAP(CChangeView)
	ADD_SKILL(BSKILL_CHANGEVIEW_NOW, ChangeView)
END_SKILL_MAP

//------------------------------------------------------
/*! \fn	CChangeView::CChangeView(
	const int iChangeViewType, 
	const EViewWidthType eWidth,
	const EViewQualityType eQuality, 
	const int ePriority,
	CWorldModel &cWorld, 
	CGameCommandSeq &cActions
)
 *  \brief KOnstruktor
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:30:11

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
CChangeView::CChangeView(
	const int iChangeViewType, 
	const EViewWidthType eWidth,
	const EViewQualityType eQuality, 
	const int ePriority,
	CWorldModel &cWorld, 
	CGameCommandSeq &cActions
)
:	CBasicSkill(iChangeViewType, iPriority, cWorld, cActions) 
{
	m_eWidth = eWidth;
	m_eQuality = eQuality;
}

//------------------------------------------------------
/*! \fn	KPDL_RESULT CChangeView::ChangeView() 
 *  \brief Zmeni uhol aj kvalitu pohladu podal zadanych parametrov
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:30:58

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CChangeView::ChangeView() 
{
	CGameCommand *pGameCommand = new CGameCommand();    
    pGameCommand->ChangeView(m_eWidth, m_eQuality);
    m_cActions.AddGameCommand(pGameCommand);
	return KPDL_SUCCESS;
}
