//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	Dribble.h
 *  \brief  Zakladna schopnost vedenia lopty
 *  \author Rado Otipka
 *  \date 2. 12. 2001 15:23:28
 *  \version 2.52.1
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef _DRIBBLE_
#define _DRIBBLE_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CDribble: public CBasicSkill 
{
private:
	DECLARE_SKILL_MAP

public:
	CDribble(
		TSkillParameterVector &cParameters,
		const int iPriority,
		CWorldModel &cWorld,
		CGameCommandSeq &cActions
	);

	CDribble(
		const int iDribleType,
		const C2DVector &cDestination,
		const double dAcceleration,
		const int iPriority,
		CWorldModel &cWorld, 
		CGameCommandSeq &cActions
	);
	
private:
	KPDL_RESULT SmartDribble();
	const double GetBallVelocity(
						C2DVector &cOutVelocityBall, 
						C2DVector &cPosition, 
						const double dAccel
				);
	const double GetBallVelocityDir(
						C2DVector &cOutVelocityBall, 
						const double dDirection, 
						const double dAccel
 				);
	const double GetBoundary();
	void Dribble(const C2DVector cDestPos, double dAccel);
	const bool IsBallOnDribblePos();
	const bool IsBallInWriteDirection(double &dDirection);
	void NextMove(
		C2DVector &cNextPos, 
		const double dBoundary, 
		const double dAngle
	);


//	KPDL_RESULT ReverseBall();

};

#endif // _DRIBBLE_
