//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	EstimateSituation.h
 *  \brief  Trieda, ktora obsahuje nezavisle metody 
 *  \brief  pouzivane na ohodnotenie situacie na ihrisku
 *  \author Rado Otipka
 *  \date 2. 12. 2001 15:23:28
 *  \version 2.52.1
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef _ESTIMATE_SITUATION_
#define _ESTIMATE_SITUATION_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


// zakladne ohodnotenie situacie
class CEstimateLocalSituation 
{
//! tuto triedu mozno plne nahradia metody CWorldModelu!!!
private:
	CWorldModel &m_cWorld;

public:
	CEstimateLocalSituation(CWorldModel &cWorld);

	bool BallKickable();
    bool BallCatchable();
    bool NearGoal(const EGoalType eGoalType);

	double MinimalDirection(const double dDistance);
	double DistToClosestOpponent(const C2DVector &cFriendPosition);

    CAgent *PlayerInWay(const double dDirection);
    CAgent *NearestFriendToBall();
    CAgent *NearestOpponentToBall();
	CAgent *FreestFriend();

    const C2DVector BallPosition(const int iTime);
    const C2DVector BallPosition(
		const int iTime, 
		const C2DVector &cNewBallSpeed
	);
    const C2DVector GetBallInterceptPosition(
		const C2DVector &cNewBallSpeed, 
		CAgent &cAgent
	);

	// vrati najblizsieho hraca zo vsekych identifikovanych 
	CAgent *NearestPlayerToBall();
	// vrati najblizsieho protihraca
	CAgent *NearestOppPlayer();	
	// vrati nablisieho spoluhraca k danemu miestu
	CAgent *NearestFriendToPos(const C2DVector &cPosition); 
};


#endif // _ESTIMATE_SITUATION_

