//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	Kick.cpp
 *  \brief	zakladna schopnost kopania do lopty
 *  \author Rado Otipka 
 *  \date 4. 12. 2001 21:49:11
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/*#define POWERRANGE(x)  (((x)>gpConfig->maxpower)?gpConfig->maxpower:             \
                        (((x)<gpConfig->minpower)?gpConfig->minpower:(x)))*/

BEGIN_SKILL_MAP(CKick)
	ADD_SKILL(BSKILL_KICK_WITH_POWER, Kick)
	ADD_SKILL(BSKILL_KICK_WITH_ACCEL, Kick2)
	ADD_SKILL(BSKILL_KICK_WITH_ACCEL_BYPASS, Kick2Bypass)
	ADD_SKILL(BSKILL_KICK_TO_POSITION, KickTo)
	ADD_SKILL(BSKILL_KICK_STOPBALL, StopBall)
	ADD_SKILL(BSKILL_KICK_PASS_INTERCEPT, InterceptPassBall)
END_SKILL_MAP

//------------------------------------------------------
/*! \fn	CKick::CKick( TParameterBSkillsVector &parameter, CLocalAgent *pl, int priority  ) :CBasicSkill( BSKILL_KICK, priority, pl ) 
 *  \brief rozhranie s vektorom parametrov
 *  \param  TParameterBSkillsVector &parameter
 *  \param  CLocalAgent *pl
 *  \param  int priority 
 *  \return
 *  \author Rado Otipka 
 *  \date 4. 12. 2001 20:09:33
 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------

CKick::CKick(
		TSkillParameterVector &cParameters,
		const int iPriority,
		CWorldModel &cWorld,
		CGameCommandSeq &cActions
	)
:	CBasicSkill(cParameters, BSKILL_KICK, iPriority, cWorld, cActions) 
{};


//------------------------------------------------------
/*! \fn	CKick::CKick(
		const int iKickType, 
		const double dAcceleration, 
		const C2DVector cPosition, 
		const int iPriority,
		CWorldModel &cWorld, 
		CGameCommandSeq &cActions
	)
 *  \brief konstruktor
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 11:52:10

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
CKick::CKick(
		const int iKickType, 
		const double dAcceleration, 
		const C2DVector cPosition, 
		const int iPriority,
		CWorldModel &cWorld, 
		CGameCommandSeq &cActions
	)
:	CBasicSkill( iKickType, iPriority, cWorld, cActions) 
{
	m_dAcceleration = dAcceleration;
	m_cPosition = cPosition;
};


//------------------------------------------------------
/*! \fn	CKick::CKick(
		const int iKickType, 
		const double dAcceleration, 
		const double dAngle, 
		const int iPriority,
		CWorldModel &cWorld, 
		CGameCommandSeq &cActions
		)
 *  \brief konstruktor
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 11:53:02

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
CKick::CKick(
		const int iKickType, 
		const double dAcceleration, 
		const double dAngle, 
		const int iPriority,
		CWorldModel &cWorld, 
		CGameCommandSeq &cActions
		)
:	CBasicSkill( iKickType, iPriority, cWorld, cActions) 
{
	m_dDirection = dAngle;
	m_dAcceleration = dAcceleration;
}

//------------------------------------------------------
/*! \fn	KPDL_RESULT CKick::Kick() 
 *  \brief Kop s urcenim momentu a sily
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 11:55:02

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CKick::Kick() 
{
	Kick( m_dPower, m_dDirection );
	return KPDL_SUCCESS;
}

//------------------------------------------------------
/*! \fn	void CKick::Kick(  double power, double dir)
 *  \brief Kopni s urcitou silou pod urcitym uhlom
 *  \param   double power
 *  \param  double di
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:35:14

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
void CKick::Kick(  double power, double dir)
{
    m_dPower = 100.0; //rado 27. 12. 2001 !!pozor!!
	CGameCommand *pGameCommand = new CGameCommand();
    pGameCommand->Kick(POWERRANGE(m_dPower), AngNormalise(dir)); //!! zmena rad na stupne
    m_cActions.AddGameCommand(pGameCommand);
}


//------------------------------------------------------
/*! \fn	KPDL_RESULT CKick::Kick2() 
 *  \brief kop zo zadanim zrychlenia a uhla otocenia
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 11:56:39

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CKick::Kick2() 
{
	Kick2( m_dAcceleration, m_dDirection );
	return KPDL_SUCCESS;
}


//------------------------------------------------------
/*! \fn	void CKick::Kick2(  double accel, double dir)
 *  \brief 
 *  \param   double accel
 *  \param  double di
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 11:57:28

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
void CKick::Kick2(  double accel, double dir)
{
    // treba dat pozor aby sme nekopli do seba (prip. do ineho hraca???)

    // treba zapocitat rychlost lopty + natocenie
    C2DVector vkick = KickRealToWanted( accel, dir);
    Kick(vkick.GetDistance(), vkick.GetAngle());

}

//------------------------------------------------------
/*! \fn	const C2DVector CKick::KickRealToWanted(  const double accel, const double dir)
 *  \brief 
 *  \param   const double accel
 *  \param  const double di
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 11:57:58

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
const C2DVector CKick::KickRealToWanted(  const double accel, const double dir)
{
    // treba zapocitat rychlost lopty + natocenie
    CMovingObject *pBall = &(m_cWorld.cBall);
    C2DVector vball = m_cWorld.cThis.RelVectorTo(pBall->cPosition);
    double dist_ball = vball.GetDistance();
    double dir_diff = fabs(RadToDeg(vball.GetAngle()));
    double factor = gpConfig->kick_power_rate * (1.0 - 0.25 * dir_diff / 180.0 - 0.25 * (dist_ball - gpConfig->player_size - gpConfig->ball_size) / gpConfig->kickable_margin);

    C2DVector vkick;
    vkick.SetAngleDistance(dir, accel);
//    vkick -= pBall->cSpeed;
	vkick.SetDistance(vkick.GetDistance() / factor);
	return vkick;
}

//------------------------------------------------------
/*! \fn	const C2DVector CKick::KickWantedToReal(const double accel, const double dir)
 *  \brief 
 *  \param   const double accel
 *  \param  const double di
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 11:58:17

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
const C2DVector CKick::KickWantedToReal(  const double accel, const double dir)
{
    // treba zapocitat rychlost lopty + natocenie
    CMovingObject *pBall = &(m_cWorld.cBall);
    C2DVector vball = m_cWorld.cThis.RelVectorTo(pBall->cPosition);
    double dist_ball = vball.GetDistance();
    double dir_diff = fabs(RadToDeg(vball.GetAngle()));
    double factor = gpConfig->kick_power_rate * (1.0 - 0.25 * dir_diff / 180.0 - 0.25 * (dist_ball - gpConfig->player_size - gpConfig->ball_size) / gpConfig->kickable_margin);

    C2DVector vkick;
    vkick.SetAngleDistance(dir, accel);
	vkick.SetDistance(vkick.GetDistance() * factor);
//    vkick += pBall->cSpeed;
	return vkick;
}

//------------------------------------------------------
/*! \fn	KPDL_RESULT CKick::KickTo() 
 *  \brief Kopni na urcitu poziciu
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 12:38:47

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CKick::KickTo() 
{
	KickTo( m_cPosition, m_dAcceleration );
	return KPDL_SUCCESS;
}	

//------------------------------------------------------
/*! \fn	void CKick::KickTo(  C2DVector pos, double accel)
 *  \brief Kopni na urcitu poziciu a urcitou rychlostou
 *  \param   C2DVector pos
 *  \param  double acce
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:35:45

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
void CKick::KickTo(  C2DVector pos, double accel)
{
    // vektor od lopty k pozicii kam treba strelit
    C2DVector v = pos - m_cWorld.cBall.cPosition;
    // uhol relativne k hracovemu natoceniu
    double ang = v.GetAngle() - m_cWorld.cThis.dHeadDirection; //!alebo Body
	C2DVector ballPos = m_cWorld.cBall.cPosition;
	if(!ballPos.IsValid())  {
		m_pListSkill->AddSkill(CTurn(
			BSKILL_TURN_TO_BALL, 
			0, 
			BSKILL_NO_PRIORITY, 
			m_cWorld, 
			m_cActions
		)); 
		return;
		//otoca sa za loptou !!!!
	}
	 if (m_cSituation.BallKickable()) 
	 {
		if (accel==0) 
		{
			// vypocet accel zo vzdialenosti pos aby tam lopta akurat prisla
			// accel = |vektor_k_pos - vektor_k_lopte|
			accel = v.GetDistance() * (1 - gpConfig->ball_decay ) + 0.1;

		}
		else 
		{
			// inac dame silu taku ako bola zadana rychlost
			accel = KickWantedToReal(accel, ang).GetDistance();
		}
		Kick2( accel, ang);
	 } 
	 else 
	 {
	/*	CMove( 
			BSKILL_MOVE_GOTO , 
			ballPos, 
			0,
			BSKILL_NO_PRIORITY, 
			m_cWorld, 
			m_cActions
			).Execute();
	*/
	 }
}


//------------------------------------------------------
/*! \fn	KPDL_RESULT CKick::Kick2Bypass() 
 *  \brief Kopni, tak ak bude pred tebou protihrac aby ho lopta obisla
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 12:39:57

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CKick::Kick2Bypass() 
{
	Kick2Bypass( m_cPosition, m_dAcceleration );
	return KPDL_SUCCESS;
}

//------------------------------------------------------
/*! \fn	void CKick::Kick2Bypass(C2DVector pos, double accel)
 *  \brief kop obklukov na supera
 *  \param C2DVector pos
 *  \param  double acce
 *  \return
 *  \author Rado Otipka 
 *  \date 9. 12. 2001 9:51:15

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
void CKick::Kick2Bypass(C2DVector pos, double accel)
{
	double delta, angle;
    CWorldModel *wModel =  &m_cWorld;
	int agentsCount = wModel->cIdentifiedAgents.size();
	C2DVector v = pos - (C2DVector)m_cWorld.cBall.cPosition;
	ESideType tMySide = m_cWorld.cThis.eSide;
	for( int i=0; i< agentsCount; i++) {
		CAgent *agent = wModel->cIdentifiedAgents[i];	
		if( agent->eSide != tMySide ) continue; 
		C2DVector vector = agent->cPosition;
		delta = 1 - ( (vector - m_cWorld.cThis.cPosition).GetDistance() / 104 );
		angle = 14 ;//+ delta * 70;
		if( fabs(vector.GetY() - v.GetY()) < angle ) {
			if(vector.GetY() > 0)
				v.SetY(v.GetY() - angle);
			else 
				v.SetY(v.GetY() + angle);
			break;
		}	else 
			if( fabs(vector.GetX() - v.GetX())< angle ) {
			if(vector.GetX() > 0)
				v.SetX(v.GetX() - angle);
			else 
				v.SetX(v.GetX() + angle);
			}
			break;
	}
	// uhol relativne k hracovemu natoceniu
    double ang = v.GetAngle() - m_cWorld.cThis.dBodyDirection;

    if (accel==0) {
        // vypocet accel zo vzdialenosti pos aby tam lopta akurat prisla
        // accel = |vektor_k_pos - vektor_k_lopte|
        accel = v.GetDistance() * (1 - gpConfig->ball_decay ) + 0.1;

	}
    else {
        // inac dame silu taku ako bola zadana rychlost
        accel = KickWantedToReal(accel, ang).GetDistance();
    }  
    Kick2( accel, ang);
} 

//------------------------------------------------------
/*! \fn	KPDL_RESULT CKick::StopBall() 
 *  \brief Zastav loptu
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 12:40:13

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CKick::StopBall() 
{
	double accel = 0;
	//toto je predchadzajuca pozicia lopty. Tu to chcem kopnut
	C2DVector pos = m_cWorld.cBall.cPrevPosition;
	// vektor od lopty k pozicii kam treba strelit
    C2DVector v = pos - (C2DVector)m_cWorld.cBall.cPosition;
    // uhol relativne k hracovemu natoceniu
    double ang = v.GetAngle() - m_cWorld.cThis.dBodyDirection;
	if(!m_cWorld.cBall.cPosition.IsValid()) return KPDL_SUCCESS;
	C2DVector ballPos = m_cWorld.cBall.cPosition;

	if(m_cSituation.BallKickable())
	{
		if(accel==0)
			// vypocet accel zo vzdialenosti pos aby tam lopta akurat prisla
			// accel = |vektor_k_pos - vektor_k_lopte|
			//accel = v.GetDistance() * (1 - gpConfig->ball_decay) + 0.1;
			accel = m_cWorld.cBall.cSpeed.GetDistance() 
					* gpConfig->ball_decay;
		else
			// inac dame silu taku ako bola zadana rychlost
			accel = KickWantedToReal(accel, ang).GetDistance();
		Kick2(accel, ang);
		return KPDL_SUCCESS;
	}
	return CMove(
		BSKILL_MOVE_GOTO, 
		ballPos, 
		100, 
		BSKILL_NO_PRIORITY, 
		m_cWorld, 
		m_cActions
	).Execute();
};

//! bolo by treba urobit 
//! aby ked pride na poziciu isiel 
//! za loptou a to skusim dorobit pri goto
//------------------------------------------------------
/*! \fn	KPDL_RESULT CKick::InterceptPassBall()
 *  \brief Vracia poziciu, kde by mohol zachytit loptu
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 12:40:25

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CKick::InterceptPassBall()
{
	double dDirection = 0.0; //uhol pod ktorym pride sprava	
	double dDeltaA, dDeltaB; 
	double dIntercetpAngle;  //uhol v sprave
	int iNumber = 0;
	char tmp[100];

	C2DVector cInterPos, posAgent;
	//najprv zisti ci vidis hraca
	//ak nie tak sa k nemu otoc
	sscanf(
		m_cWorld.cHear.sMessage.c_str(),
		"%s %d %.2f",tmp, &iNumber, 
		&dIntercetpAngle
	);

	if(m_cWorld.cHear.iPlayTime != m_cWorld.cTime.iPlayTime	||
	   m_cWorld.cHear.eMsgType == HM_Self			||
	   m_cWorld.cHear.eMsgType != HM_Other			||
	   m_cWorld.cThis.iNumber  != iNumber			||
	   strcmp(tmp,"nahravka:") != 0
	) 
		return KPDL_SUCCESS;
	dDirection = m_cWorld.cHear.dDirection;

	int number = 1;
	int agentsCount = m_cWorld.cIdentifiedAgents.size();
	ESideType tMySide = m_cWorld.cThis.eSide;
	for(int i=0; i < agentsCount; i++) 
	{
		CAgent *agent = m_cWorld.cIdentifiedAgents[i];
		if( agent->eSide == tMySide ) 
			if( agent->iNumber == number ) 
			{
				posAgent = agent->cPosition;
				break;
			}
	} 

	if(i == agentsCount)  
	{
		CTurn(	BSKILL_TURN_2,
				dDirection,
				BSKILL_NO_PRIORITY,
				m_cWorld, 
				m_cActions
		).Execute();
		return KPDL_UNSUCCESS;
	} 
	else 
	{
		double dist = (m_cWorld.cThis.cPosition - posAgent).GetDistance();
		dDeltaA = dist * sin(dIntercetpAngle);
		dDeltaB = dist * cos(dIntercetpAngle);
		if(dIntercetpAngle > 0)
			cInterPos.SetY(m_cWorld.cThis.cPosition.GetX() - dDeltaA);
		else 
			cInterPos.SetY(m_cWorld.cThis.cPosition.GetX() - dDeltaB);
		cInterPos.SetX(posAgent.GetX()+dDeltaB);
		
		m_pListSkill->AddSkill(
			CMove(
				BSKILL_MOVE_GOTO,
				cInterPos, 
				0,
				BSKILL_DEFAULT_PRIORITY+1, 
				m_cWorld, 
				m_cActions)
			
		);
		return KPDL_SUCCESS;
	}
}
