//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	Kick.h
 *  \brief  Zakladna schopnost kopania do lopty
 *  \author Rado Otipka
 *  \date 2. 12. 2001 15:23:28
 *  \version 2.52.1
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef _KICK_
#define _KICK_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CKick: public CBasicSkill
{
private:
	DECLARE_SKILL_MAP
public:
	CKick(
		TSkillParameterVector &cParameters,
		const int iPriority,
		CWorldModel &cModel,
		CGameCommandSeq &cActions
	);
	CKick(
		const int iKickType, 
		const double dAcceleration, 
		const C2DVector cPosition, 
		const int iPriority,
		CWorldModel &cWorld, 
		CGameCommandSeq &cActions
	);
	CKick(
		const int iKickType, 
		const double dAcceleration, 
		const double dAngle, 
		const int iPriority,
		CWorldModel &cWorld, 
		CGameCommandSeq &cActions
	);

	KPDL_RESULT StopBall();

private:
	KPDL_RESULT Kick();
	KPDL_RESULT Kick2();
	KPDL_RESULT KickDistance();
	KPDL_RESULT KickTo();
	KPDL_RESULT Kick2Bypass();
	KPDL_RESULT InterceptPassBall();

	const C2DVector KickRealToWanted(
		const double dAcceleration, 
		const double dDirection
	);
	const C2DVector KickWantedToReal(
		const double dAcceleration,
		const double dDirection
	);
	//! Rado Otipka 2.4.2002 21:01:25, stare funkcie, ktore su volane este s parametrami, s niektorych funkcii
	void Kick(double power, double dir);
	void Kick2Bypass(C2DVector pos, double accel);
	void KickTo(C2DVector pos, double accel);
	void Kick2(  double accel, double dir);
};

#endif // _KICK_
