//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	Move.cpp
*  \brief	zakladna schopnost pohybu hraca po ihrisku
*  \author Rado Otipka 
*  \date 4. 12. 2001 21:49:11
*  \version 
*  \bug 
*/
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
*/
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------
/*! \fn	CMove::CMove(
			 TSkillParameterVector &cParameter,
			 const int iPriority,
			 CWorldModel &cWorld, 
			 CGameCommandSeq &cActions
			 )
 *  \brief Konstruktor
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 15:53:25

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
CMove::CMove(
			 TSkillParameterVector &cParameter,
			 const int iPriority,
			 CWorldModel &cWorld, 
			 CGameCommandSeq &cActions
			 )
			 : CBasicSkill(cParameter, BSKILL_MOVE, iPriority, cWorld, cActions) 
{
}

//------------------------------------------------------
/*! \fn	CMove::CMove(
			 const int iMoveType, 
			 const double dAcceleration,
			 const int iPriority,
			 CWorldModel &cWorld, 
			 CGameCommandSeq &cActions
			 )
 *  \brief KOnstruktor
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 15:53:06

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
CMove::CMove(
			 const int iMoveType, 
			 const double dAcceleration,
			 const int iPriority,
			 CWorldModel &cWorld, 
			 CGameCommandSeq &cActions
			 )
			 :	CBasicSkill(iMoveType, iPriority, cWorld, cActions) 
{
	m_dAcceleration = dAcceleration;
	m_dPower = dAcceleration;
};

//------------------------------------------------------
/*! \fn	CMove::CMove(
			 const int iMoveType,
			 const C2DVector &cPosition, 
			 const double dAcceleration,
			 const int iPriority,
			 CWorldModel &cWorld,
			 CGameCommandSeq &cActions
			 )
 *  \brief Konstruktor
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 15:52:43

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
CMove::CMove(
			 const int iMoveType,
			 const C2DVector &cPosition, 
			 const double dAcceleration,
			 const int iPriority,
			 CWorldModel &cWorld,
			 CGameCommandSeq &cActions
			 )
			 :	CBasicSkill(iMoveType, iPriority, cWorld, cActions) 
{
	m_cPosition = cPosition;
	m_dAcceleration = dAcceleration;
};

BEGIN_SKILL_MAP(CMove)
	ADD_SKILL(BSKILL_MOVE_DASH, Dash)
	ADD_SKILL(BSKILL_MOVE_GOTO, GoTo)
	ADD_SKILL(BSKILL_MOVE_TO, Move)
	ADD_SKILL(BSKILL_MOVE_GOTO_PLAYER, GoToPlayer)
	ADD_SKILL(BSKILL_MOVE_GOTO_BALL, GotoBallPosition)
END_SKILL_MAP

/////////////////////////////////////////////////////////////////////////////////////////////

//------------------------------------------------------
/*! \fn	KPDL_RESULT CMove::AtaptPowerWithStamina(
									 double &dAdaptPower, 
									 const double dPower
									)
 *  \brief adaptuj velkost sily na vykonanie akcie, 
 *  \brief podla akcie ktoru ides vykonat a podal staminy
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 12:50:52

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CMove::AtaptPowerWithStamina(
									 double &dAdaptPower, 
									 const double dPower
										 ) 
{
	double dNewAccell;
	double dStamina;
	switch(m_eEffort) 
	{
	case EFF_Maximum: 
		dStamina = m_cWorld.cThis.dStamina;
		break;
	case EFF_Medium: 
		if(gpConfig->stamina_max*gpConfig->effort_dec_thr > 
			m_cWorld.cThis.dStamina
		)
		{
			dStamina = 0.5 * gpConfig->stamina_inc_max ;
		} 
		else 
		{
			dStamina = 
				m_cWorld.cThis.dStamina - 
				gpConfig->stamina_max*gpConfig->effort_dec_thr;
		}
		break;

	case EFF_Minimum: 
		if(gpConfig->stamina_max*gpConfig->effort_dec_thr > 
			m_cWorld.cThis.dStamina
		)
		{
			dStamina = 0.5 * gpConfig->stamina_inc_max;
		} 
		else 
			if(gpConfig->stamina_max*gpConfig->effort_inc_thr
				> m_cWorld.cThis.dStamina
			)
				dStamina = 0.5 * gpConfig->stamina_inc_max;
			else
				dStamina = m_cWorld.cThis.dStamina - gpConfig->stamina_max*gpConfig->effort_inc_thr;
		break;
	}
	if(dStamina < 0.4*gpConfig->stamina_inc_max) 
		dStamina = 0.5*gpConfig->stamina_inc_max;
	
	if(dPower < 0) 
	{
		if(-2*dPower > dStamina) 
		{
			dAdaptPower = -dStamina ;		
		} 
		else
			dAdaptPower = -2*dPower;
		if(!m_cWorld.cThis.cSpeed.IsValid()) return KPDL_SUCCESS;

		dNewAccell = DashWantedToReal(-dAdaptPower/2.0);

		if(dNewAccell > gpConfig->player_speed_max) 
		{
			dAdaptPower = DashRealToWanted(
				dNewAccell - gpConfig->player_speed_max
			) / 2.0;
		} 
		return KPDL_SUCCESS;	
	} 
	else 
	{
		if(dPower > dStamina) 
		{
			dAdaptPower = dStamina;		
		}
		else 
			dAdaptPower = dPower;
		if(!m_cWorld.cThis.cSpeed.IsValid()) return KPDL_SUCCESS;
		dNewAccell = DashWantedToReal(dAdaptPower);
		if(dNewAccell > gpConfig->player_speed_max) 
		{
			dAdaptPower = DashRealToWanted(
				dNewAccell - gpConfig->player_speed_max
			);
		} 
		return KPDL_SUCCESS;	
	}
}

//------------------------------------------------------
/*! \fn	KPDL_RESULT CMove::Dash()
 *  \brief Vykonaj pohyb dopredu
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 12:51:59

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CMove::Dash()
{
	double dNewPower;
	int iNumOfUpdate=0;
    CGameCommand *pGameCommand = new CGameCommand();
	AtaptPowerWithStamina(dNewPower, m_dPower);
	pGameCommand->Dash(POWERRANGE(dNewPower));
	m_cActions.AddGameCommand(pGameCommand);
	return KPDL_SUCCESS;
}


//------------------------------------------------------
/*! \fn	KPDL_RESULT CMove::Move()
 *  \brief Presun hraca na urcenu poziciu
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 12:52:15

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CMove::Move()
{
	if ( m_cWorld.cTime.ePlayMode == PM_PlayOn )
		return KPDL_ERROR;

	// ak si vzdialeny menej ako 2 metre, tak hned skonci
	if( (m_cPosition - m_cWorld.cThis.cPosition).GetDistance() < MIN_DIST ) 
	{
		return KPDL_SUCCESS;
	}

    CGameCommand *pGameCommand = new CGameCommand();	
    pGameCommand->Move(m_cPosition.GetX(), m_cPosition.GetY());
	m_cActions.AddGameCommand(pGameCommand);
	return KPDL_SUCCESS;
}

//------------------------------------------------------
/*! \fn	KPDL_RESULT CMove::GoTo()
 *  \brief Chod na urcenu poziciu
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 12:52:41
 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CMove::GoTo()
{
	C2DVector pos = m_cPosition;
	double accel = m_dAcceleration;
    C2DVector topos = m_cWorld.cThis.RelVectorTo(pos);
	
	//C2DVector topos = m_cWorld.cThis.cPosition - pos;

    double ang = topos.GetAngle(); //- m_cWorld.cThis.dBodyDirection;
	if(m_cWorld.cThis.iLastSeen != 0) return KPDL_UNSUCCESS;
	C2DVector deltaPos = 	m_cWorld.cThis.cPosition ;
	C2DVector deltaPos2 =  m_cWorld.cBall.cPosition;
	// ak si vzdialeny menej ako 2 metre, tak hned skonci
	if( (pos - m_cWorld.cThis.cPosition).GetDistance() < MIN_DIST ) 
	{
		return KPDL_SUCCESS;
	}   

	double mindir = DegToRad( 15 - 8*exp(-topos.GetDistance() * 0.2f ));
	accel = 1;
    if ((ang > -mindir) && (ang < mindir)) 
    {
        if (accel==0) 
		{ 
            // vypocet accel, aby tam agent presne zastavil
            accel = (topos - (C2DVector)m_cWorld.cThis.cSpeed).GetDistance();
        }		
		m_dAcceleration = accel;
		Dash2();
    }
    else 
    {
	//CChangeView(BSKILL_CHAGEVIEW_NOW ,VISUAL_RANGE_WIDE, 1, GetAgent(), 0).Execute() ;
		CTurn(BSKILL_TURN_2,
			ang,
			BSKILL_NO_PRIORITY, 
			m_cWorld, 
			m_cActions
		).Execute(); // Rado Otipka 2. 12. 2001 15:27:41
		m_cWorld.cThis.iLastSeen == 1;
    }
	// Ak si vzdialeny od miesta viac ako 2 metre, tak este nekonci
	if( (pos - m_cWorld.cThis.cPosition).GetDistance() > MIN_DIST ) 
	{
		return KPDL_UNSUCCESS;
	}
	return KPDL_SUCCESS;
}

//------------------------------------------------------
/*! \fn	KPDL_RESULT CMove::Dash2()
 *  \brief Pohyb na urcenu poziciu
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 12:54:06

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CMove::Dash2()
{
	//m_dAcceleration = DashRealToWanted(m_dAcceleration);
	m_dPower = DashRealToWanted(m_dAcceleration);
    Dash();
	return KPDL_SUCCESS;
}


//------------------------------------------------------
/*! \fn	double CMove::DashRealToWanted(double accel)
 *  \brief Vypocita potrebnu silu, pri urcenej rychlosti
 *  \param double acce
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 12:57:36

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
double CMove::DashRealToWanted(double accel)
{
    // todo: zapocitat staminu
    return accel / (gpConfig->dash_power_rate*m_cWorld.cThis.dEffort);
	//return accel ;
}

//------------------------------------------------------
/*! \fn	double CMove::DashWantedToReal(double power) 
 *  \brief Vypocita zrychlenie na zaklade sily
 *  \param double powe
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 12:58:01

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
double CMove::DashWantedToReal(double power) 
{
	return gpConfig->dash_power_rate*m_cWorld.cThis.dEffort*power;
}

//------------------------------------------------------
/*! \fn	KPDL_RESULT CMove::GoToPlayer() 
 *  \brief Presun sa k urcitemu hracovi
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 12:58:21

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CMove::GoToPlayer() 
{
	int number = m_iPlayerNumber;  	

	if( number == m_cWorld.cThis.iNumber ) 
		return KPDL_SUCCESS; 
	C2DVector posAgent(0,0);
	int agentsCount = m_cWorld.cIdentifiedAgents.size();
	ESideType tMySide = m_cWorld.cThis.eSide;
	
	for(int i=0; i < agentsCount; i++) 
	{
		CAgent *agent = m_cWorld.cIdentifiedAgents[i];
		if( agent->eSide == tMySide ) 
		{
			if( agent->iNumber == number ) 
			{
				if(!agent->cPosition.IsValid()) return KPDL_SUCCESS;
				posAgent = agent->cPosition;
			}
		}
	}
	if( i == agentsCount ) 
	{
		//svojho agenta s takym cislom nevidim, koncim
		return KPDL_SUCCESS; 
	}
	else  
	{
		if ((posAgent - m_cWorld.cThis.cPosition).GetDistance() < MIN_DIST)
				return KPDL_SUCCESS;
		CMove(BSKILL_MOVE_GOTO, 
			posAgent, 
			0, 
			BSKILL_NO_PRIORITY, 
			m_cWorld, 
			m_cActions
		).Execute();
		return KPDL_UNSUCCESS;
	}	
}

//------------------------------------------------------
/*! \fn	void CMove::GotoBallPosition() 
*  \brief chod za loptou, este by sa tam hodila funkcnost, ktora by zabezpecovala aby si dopredu dopocital poziciu lopty
*  \param double acce
*  \return
*  \author Rado Otipka 
*  \date 17. 12. 2001 8:09:32

  *  \bug 
*/
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
*/
//------------------------------------------------------
KPDL_RESULT CMove::GotoBallPosition() 
{
	double accel = m_dAcceleration;
	C2DVector ballPos;
	if(m_cWorld.cThis.iLastSeen != 0) return KPDL_UNSUCCESS;

	if(!m_cWorld.cBall.cPosition.IsValid())
	{
		/*	m_pListSkill->AddSkill(CTurn(
				BSKILL_TURN_TO_BALL, 
				0, 
				BSKILL_NO_PRIORITY, 
				m_cWorld, 
				m_cActions
			)); 
			return KPDL_SUCCESS;
		*/
/*		CTurn(	
				BSKILL_TURN_TO_BALL, 
				0, 
				BSKILL_NO_PRIORITY, 
				m_cWorld, 
				m_cActions
			).Execute();*/
		CTurn( 
			BSKILL_TURN_2,
			DegToRad(45),
			BSKILL_NO_PRIORITY,
			m_cWorld, 
			m_cActions
		).Execute();
		gpBSkillLog->Write(true,"Hladam loptu; cas: %s head: %s", 
			m_cWorld.GetAttribute("time.playTime").c_str(), 
			m_cWorld.GetAttribute("me.headDir").c_str()
		);
		m_cWorld.cThis.iLastSeen = 1;	
		return KPDL_UNSUCCESS;
	}

	if(m_cSituation.BallKickable() ) return KPDL_SUCCESS;	
	ballPos = m_cWorld.cBall.cPosition;
	
	/*m_cSituation.GetBallInterceptPosition(
						m_cWorld.cBall.cSpeed, 
						m_cWorld.cThis
	);	*/
	C2DVector topos = m_cWorld.cThis.RelVectorTo(ballPos);
	double ang = topos.GetAngle();
	ang = AngNormalise(ang); 
	//C2DVector delta =  ballPos - m_cWorld.cThis.cPosition;
//	double dir = atan2(delta.GetY(), delta.GetX()) - m_cWorld.cThis.dHeadDirection ;

//	ang = AngNormalise(dir); 

	double mindir = DegToRad(15 - 8*exp(-topos.GetDistance() * 0.2f));


	gpBSkillLog->Write(
		true, 
		"cas: %s, uhol o ktory sa mam otocit %.2f, netocenie hlavy %.2f, netocenie tela %.2f", 
		m_cWorld.GetAttribute("time.playTime").c_str(),
		RadToDeg(ang), 
		RadToDeg(m_cWorld.cThis.dHeadDirection),
		RadToDeg(m_cWorld.cThis.dBodyDirection)
	);
	accel = 1;
    if ((ang > -mindir) && (ang < mindir)) 
    {
        if (accel==0) 
		{ 
            // vypocet accel, aby tam agent presne zastavil
//            accel = (topos - (C2DVector)m_cWorld.cThis.cSpeed).GetDistance();
        }		 
		m_dAcceleration = accel;
		if(
			(m_cWorld.cBall.cPosition - 
				m_cWorld.cThis.cPosition).GetDistance() < 
			gpConfig->kickable_area*10
		) 
			m_eEffort = EFF_Maximum;
		Dash2();
		m_cWorld.cThis.iLastSeen = 1;
		gpBSkillLog->Write(true, "Idem dopredu");
		if( fabs(m_cWorld.cThis.dHeadDirection)>0.05 ) 
		{
			/*GetAgent()->listSkl->AddSkill(
				new  CTurnNeck( 
					BSKILL_TURN_NECK_BASIC,  
					- GetAgent()->dNeckDirection,
					GetAgent() , 
					99)
			);
			GetAgent()->dNeckDirection = 0;*/
		}
		else 
		{
			/*GetAgent()->listSkl->AddSkill(
					new  CTurnNeck( 
						BSKILL_TURN_NECK_BASIC, 
						0.1 ,
						GetAgent() , 
						99)
					);*/
			//neckTurn = 0.1;
		}
    }
    else 
    {
		// Rado Otipka 2. 12. 2001 15:27:41
	/*	if(ang < 0) 
		{
			if(ang + 3.14 < fabs(ang)) ang = ang + 3.14;
		} 
		else 
		{ 
			if(fabs(ang - 3.14) < ang) ang = (ang - 3.14);
		}
		*/
		CTurn(
			BSKILL_TURN_2, 
			ang, 
			BSKILL_NO_PRIORITY, 
			m_cWorld, 
			m_cActions
		).Execute(); 
		gpBSkillLog->Write(true, "Otacam sa");
		m_cWorld.cThis.iLastSeen = 1;
	}
	return KPDL_UNSUCCESS;
}