//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	Move.h
 *  \brief  Trieda CMove implementujuca 
 *  \brief  zakladne schopnosti pohybu po ihrisku
 *  \author Rado Otipka
 *  \date 2. 12. 2001 15:23:28
 *  \version 2.52.1
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef _MOVE_
#define _MOVE_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CMove: public CBasicSkill
{
	DECLARE_SKILL_MAP
public:
	CMove(
		TSkillParameterVector &cParameters,
		const int iPriority,
		CWorldModel &cWorld, 
		CGameCommandSeq &cActions
	);
	CMove(
		const int iMoveType, 
		const double dAcceleration,
		const int iPriority,
		CWorldModel &cWorld, 
		CGameCommandSeq &cActions
	);
	CMove(
		const int iMoveType,
		const C2DVector &cPosition, 
		const double dAcceleration,
		const int iPriority,
		CWorldModel &cWorld,
		CGameCommandSeq &cActions
	);

private:
	KPDL_RESULT Dash();
	KPDL_RESULT Dash2();
	KPDL_RESULT Move(const double dX, const double dY);
	KPDL_RESULT Move();
    KPDL_RESULT GoTo();
	KPDL_RESULT GoToPlayer(); // uz funkcna, tak ako tak
	KPDL_RESULT GotoBallPosition();
	KPDL_RESULT AtaptPowerWithStamina(
		double &dAdaptPower,
		const double dPower
	);
	double DashRealToWanted(const double dAcceleration);
	double CMove::DashWantedToReal(double power);
};

#endif // _MOVE_
