//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	Pass.h
 *  \brief  Zakladna schopnost prihravky
 *  \author Rado Otipka
 *  \date 2. 12. 2001 15:23:28
 *  \version 2.52.1
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef _PASS_
#define _PASS_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef map<double, int> MapDoubleInt;
typedef map<double, int> ::iterator IMapDoubleInt;
typedef map<double, int> ::value_type VMapDoubleInt;

class CPass: public CBasicSkill
{

	DECLARE_SKILL_MAP
private:
	MapDoubleInt m_mRelAnglePlus; 
	MapDoubleInt m_mRelAngleMinus;
	MapDoubleInt m_mRelDist;
	double m_dAngle ;

public:
	CPass(
		TSkillParameterVector &cParameters, 
		const int iPriority,
		CWorldModel &cWorld,
		CGameCommandSeq &cActions
	);

private:
	KPDL_RESULT PassToPlayer(); 
	KPDL_RESULT SayPassMessage(const double dAngle);
	KPDL_RESULT FillRelParamMaps(
						const double dDistToReceiver, 
						const double dAngleToReceiver
				);
	KPDL_RESULT Pass2();
};

#endif // _PASS_
