//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	Say.cpp
 *  \brief	Implementacia zakladnej schopnosti zakricania spravy
 *  \author Rado Otipka 
 *  \date 4. 12. 2001 21:49:11
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//------------------------------------------------------
/*! \fn	CSay::CSay(
		TSkillParameterVector &cParameters, 
		const int iPriority,
		CWorldModel &cWorld,
		CGameCommandSeq &cActions
		) 
 *  \brief konstruktor
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:05:55

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
CSay::CSay(
		TSkillParameterVector &cParameters, 
		const int iPriority,
		CWorldModel &cWorld,
		CGameCommandSeq &cActions
		) 
:		CBasicSkill(cParameters, BSKILL_SAY, iPriority, cWorld, cActions) 
{}

//------------------------------------------------------
/*! \fn	CSay::CSay(
	const int iSayType, 
	const string &sMessage,  
	const int iPriority,
	CWorldModel &cWorld,
	CGameCommandSeq &cActions
	)
 *  \brief KOnstruktor
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 15:56:29

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
CSay::CSay(
	const int iSayType, 
	const string &sMessage,  
	const int iPriority,
	CWorldModel &cWorld,
	CGameCommandSeq &cActions
)
:	CBasicSkill(iSayType, iPriority, cWorld, cActions)
{
	m_sMessage = sMessage;
};


//------------------------------------------------------
/*! \fn	KPDL_RESULT CSay::Say() 
 *  \brief Funkcia, ktora implementuje samotne zakricanie spravy
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:07:25

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CSay::Say() 
{
    CGameCommand *pGameCommand = new CGameCommand();    
    pGameCommand->Say(m_sMessage);
    m_cActions.AddGameCommand(pGameCommand);
	return KPDL_SUCCESS;
}
