//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	Turn.cpp
 *  \brief	zakladna schopnost zmeny smeru pohybu hraca
 *  \author Rado Otipka 
 *  \date 4. 12. 2001 21:49:11
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BEGIN_SKILL_MAP(CTurn)
	ADD_SKILL(BSKILL_TURN_ME, Turn)
	ADD_SKILL(BSKILL_TURN_TO, TurnTo)
	ADD_SKILL(BSKILL_TURN_2, Turn2)
	ADD_SKILL(BSKILL_TURN_TO_BALL, TurnToBall)
END_SKILL_MAP


//------------------------------------------------------
/*! \fn	CTurn::CTurn(
 *  \brief KOnstruktor
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:13:35

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
CTurn::CTurn(
		TSkillParameterVector &cParameters, 
		const int iPriority,
		CWorldModel &cWorld,
		CGameCommandSeq &cActions
    	)
:	CBasicSkill(cParameters, BSKILL_TURN, iPriority, cWorld, cActions) 
{
}

//------------------------------------------------------
/*! \fn	CTurn::CTurn(
		const int iTurnType,
		const double dMoment, 
		const int iPriority,
		CWorldModel &cWorld, 
		CGameCommandSeq &cActions
		)
 *  \brief Konstruktor
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:13:45

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
CTurn::CTurn(
		const int iTurnType,
		const double dMoment, 
		const int iPriority,
		CWorldModel &cWorld, 
		CGameCommandSeq &cActions
		)
:	CBasicSkill(iTurnType, iPriority, cWorld, cActions)
{
	m_dMoment  = dMoment;
}

//------------------------------------------------------
/*! \fn	CTurn::CTurn(
		const int iTurnType, 
		const C2DVector &cPosition, 
		const int iPriority,
		CWorldModel &cWorld,
		CGameCommandSeq &cActions
	)
 *  \brief Konstruktor
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:13:59

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
CTurn::CTurn(
		const int iTurnType, 
		const C2DVector &cPosition, 
		const int iPriority,
		CWorldModel &cWorld,
		CGameCommandSeq &cActions
)
:	CBasicSkill(iTurnType, iPriority, cWorld, cActions)
{
	m_cPosition = cPosition;
}

//------------------------------------------------------
/*! \fn	KPDL_RESULT CTurn::Turn()
 *  \brief Otoc sa o urcity moment
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:16:23

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CTurn::Turn()
{
	double moment = m_dMoment;
    CGameCommand *pGameCommand = new CGameCommand();
    
    double moment2 = AngNormalise(moment);
    moment2 = MOMENTRANGE(moment2);  
    
    if ((moment2<-MINTURN) || (moment2>MINTURN)) 
	{
        pGameCommand->Turn(moment2);
        m_cActions.AddGameCommand(pGameCommand);
    }
	else 
	{
        delete pGameCommand;
    }
	return KPDL_SUCCESS;
}

//------------------------------------------------------
/*! \fn	double CTurn::TurnWantedToReal(  double angle)
 *  \brief Vstupom je uhol otocenia vystupom je moment
 *  \param   double angl
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:16:46

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
double CTurn::TurnWantedToReal(  double angle)
{
    return angle / (1.0 + gpConfig->inertia_moment * m_cWorld.cThis.cSpeed.GetDistance());
}

//------------------------------------------------------
/*! \fn	double CTurn::TurnRealToWanted(  double moment)
 *  \brief Vstupom je moment a vystupom je uhol o ktory sa otoci
 *  \param   double momen
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:17:06

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
double CTurn::TurnRealToWanted(  double moment)
{
    return moment * (1.0 + DegToRad(gpConfig->inertia_moment) * m_cWorld.cThis.cSpeed.GetDistance());
}

//------------------------------------------------------
/*! \fn	KPDL_RESULT CTurn::TurnTo()
 *  \brief Otoc sa na urcenu poziciu
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:17:28

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CTurn::TurnTo()
{
	m_dMoment = m_cWorld.cThis.RelVectorTo(m_cPosition).GetAngle();
    return Turn2();
	
}

//------------------------------------------------------
/*! \fn	KPDL_RESULT CTurn::Turn2()
 *  \brief Otoc sa o urceny uhol
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:17:51

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CTurn::Turn2()
{
	m_dMoment = TurnRealToWanted(m_dMoment);
    return Turn();
}


//------------------------------------------------------
/*! \fn	KPDL_RESULT CTurn::TurnToBall() 
 *  \brief Natoc sa k lopte
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:18:03

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CTurn::TurnToBall() 
{
	C2DVector ballPos = m_cWorld.cBall.cPosition;
	C2DVector topos = m_cWorld.cThis.RelVectorTo(ballPos);
	double ang = topos.GetAngle();
	if (m_seeBall==-1) 
	{
		(ang>0) ? m_seeBall=0 : m_seeBall=1;
	}
	//zmen uhol pohladu ak potrebujes
	if (m_cWorld.cThis.dViewAngle != 0.5 * PI)
		CChangeView(
			BSKILL_CHANGEVIEW_NOW, 
			VW_Normal, 
			VQ_None,
			BSKILL_NO_PRIORITY, 
			m_cWorld, 
			m_cActions
		).Execute();

	if (m_cWorld.cBall.cPosition.IsValid())
	{ 
		//aky mas uhol pohladu, otoc sa o ten uhol
		double viewAngle = m_cWorld.cThis.dViewAngle;
		//if(m_seeBall == 1) viewAngle= -viewAngle;
		CTurn( 
			BSKILL_TURN_2,
			viewAngle/3.0,
			BSKILL_NO_PRIORITY,
			m_cWorld, 
			m_cActions
		).Execute();
		return KPDL_UNSUCCESS;	
	} 
	else 
	{
		//ak je uhol otocenia voci lopte mensi ako 0.1 tak sa neotacaj
		if(fabs(ang) < 0.1) return KPDL_SUCCESS; 
		else 
			CTurn (
				BSKILL_TURN_2, 
				ang, 
				BSKILL_NO_PRIORITY,
				m_cWorld, 
				m_cActions
			).Execute();
	}
	return KPDL_UNSUCCESS;
}


