//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	Turn.h
 *  \brief  Zakladna schopnost otocenie hraca
 *  \author Rado Otipka
 *  \date 2. 12. 2001 15:23:28
 *  \version 2.52.1
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef _TURN_
#define _TURN_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CTurn: public CBasicSkill
{
	DECLARE_SKILL_MAP	
public:
	CTurn(
		TSkillParameterVector &cParameters, 
		const int iPriority,
		CWorldModel &cWorld,
		CGameCommandSeq &cActions
	);
	CTurn(
		const int iTurnType,
		const double dMoment, 
		const int iPriority,
		CWorldModel &cWorld, 
		CGameCommandSeq &cActions
	);
	CTurn(
		const int iTurnType, 
		const C2DVector &cPosition, 
		const int iPriority,
		CWorldModel &cWorld,
		CGameCommandSeq &cActions
	);

private:
	KPDL_RESULT Turn();
	KPDL_RESULT Turn2();
	KPDL_RESULT TurnTo();
	KPDL_RESULT TurnToBall();

    double TurnWantedToReal(const double dAngle);
    double TurnRealToWanted(const double dMoment);
	int m_seeBall;
};

#endif // _TURN_