//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	TurnNeck.cpp
 *  \brief	zakladna schopnost otacania krkom
 *  \author Rado Otipka 
 *  \date 4. 12. 2001 21:49:11
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//------------------------------------------------------
/*! \fn	CTurnNeck::CTurnNeck(
 *  \brief KOnstruktor
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:18:24

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
CTurnNeck::CTurnNeck(
		TSkillParameterVector &cParameters, 
		const int iPriority,
		CWorldModel &cWorld,
		CGameCommandSeq &cActions
	)
:	CBasicSkill(cParameters, BSKILL_TURN_NECK, iPriority, cWorld, cActions) 
{
	//m_skillSkillType = BSKILL_TURN_NECK_TO;
}


//------------------------------------------------------
/*! \fn	CTurnNeck::CTurnNeck(
		const int iTurnType, 
		const double dMoment, 
		const int iPriority,
		CWorldModel &cWorld, 
		CGameCommandSeq &cActions
	)
 *  \brief Konstruktor
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:18:30

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
CTurnNeck::CTurnNeck(
		const int iTurnType, 
		const double dMoment, 
		const int iPriority,
		CWorldModel &cWorld, 
		CGameCommandSeq &cActions
)
:	CBasicSkill(iTurnType, iPriority, cWorld, cActions)
{
	m_dMoment = dMoment;		
}


//------------------------------------------------------
/*! \fn	CTurnNeck::CTurnNeck(
		const int iTurnType, 
		const C2DVector &cPosition, 
		const int iPriority,
		CWorldModel &cWorld, 
		CGameCommandSeq &cActions
	)
 *  \brief Konstruktor
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:18:40

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
CTurnNeck::CTurnNeck(
		const int iTurnType, 
		const C2DVector &cPosition, 
		const int iPriority,
		CWorldModel &cWorld, 
		CGameCommandSeq &cActions
)
:	CBasicSkill(iTurnType, iPriority, cWorld, cActions)
{
	m_cPosition = cPosition;
}

BEGIN_SKILL_MAP(CTurnNeck)
	ADD_SKILL(BSKILL_TURN_NECK_BASIC, TurnNeck)
	ADD_SKILL(BSKILL_TURN_NECK_TO, TurnNeckTo)
	ADD_SKILL(BSKILL_TURN_NECK_TO_BALL, TurnNeckToBall)
	ADD_SKILL(BSKILL_TURN_NECK_STRAIGHT, TurnNeckStraight)
END_SKILL_MAP


//------------------------------------------------------
/*! \fn	KPDL_RESULT CTurnNeck::TurnNeckStraight( )
 *  \brief Otoc hlavu dopredu
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:18:53

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CTurnNeck::TurnNeckStraight( )
{
    double m_dMoment =  m_cWorld.cThis.dBodyDirection - m_cWorld.cThis.dHeadDirection;
    if ((m_dMoment < DegToRad(-1.0)) || (m_dMoment > DegToRad(1.0))) TurnNeck();
	return KPDL_SUCCESS;
}

//------------------------------------------------------
/*! \fn	KPDL_RESULT CTurnNeck::TurnNeckToBall( )
 *  \brief Otoc hlavu k lopte
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:19:03

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CTurnNeck::TurnNeckToBall( )
{
    CMovingObject *pBall = &(m_cWorld.cBall);
    C2DVector vball = pBall->cPosition - m_cWorld.cThis.cPosition;
    m_dMoment = vball.GetAngle() - m_cWorld.cThis.dHeadDirection;
    return TurnNeck();
}

//------------------------------------------------------
/*! \fn	KPDL_RESULT CTurnNeck::TurnNeckTo()
 *  \brief Otoc hlavu na urcitu poziciu
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:19:16

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CTurnNeck::TurnNeckTo()
// FIXME: ak urobim turn, tak turnneckto sa musi od toho odpocitat!!!
// FIXME: bude treba urobit kontrolu ci sa mozem az tam otocit
//        a pripadne orezat, nech pri recompute nepocitam s blbostami
{
    C2DVector pom = m_cPosition - m_cWorld.cThis.cPosition;
	C2DVector necktopos = Rot(pom, -m_cWorld.cThis.dHeadDirection);
	m_dMoment = necktopos.GetAngle();
    return TurnNeck();

//    double n = - ( GetAgent()->dHeadDirection - GetAgent()->dDirection );
//    double n = GetAgent()->dDirection;

//    double n = RelVectorTo(GetAgent(), pos).GetAngle() - GetAgent()->dDirection;
//    n += Rot(pos - (C2DVector)GetAgent()->cPosition, -GetAgent()->dHeadDirection).GetAngle();

//    n+=DegToRad(10);

//    TurnNeck(GetAgent(), n);
}

//------------------------------------------------------
/*! \fn	KPDL_RESULT CTurnNeck::TurnNeck()
 *  \brief Otoc hlavu o urcity uhol
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 13:19:33

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CTurnNeck::TurnNeck()
{
    CGameCommand *pGameCommand = new CGameCommand();
    
    double moment2 = RadToDeg(AngNormalise(m_dMoment));  
    moment2 = NECKRANGE(moment2);  pGameCommand->TurnNeck(moment2);
    m_cActions.AddGameCommand(pGameCommand);
	return KPDL_SUCCESS;
}
