//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	Config.h
 *  \brief 
 *  \author KPDL
 *  \date 17.4.2002 22:20:15
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef _CONFIG_
#define _CONFIG_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CConfig;

extern CConfig *gpConfig;

typedef map<string, string> TConfigMap;
typedef TConfigMap::iterator TConfigMapIterator;

class CConfig
{
private:
    TConfigMap m_cConfigMap;

public:
    #define CFG_AMOUNT(Param, Value) double Param
    #define CFG_ANGLE(Param, Value) double Param
    #define CFG_COUNT(Param, Value) int Param
    #define CFG_BOOL(Param, Value) bool Param
    #define CFG_STRING(Param, Value) string Param

    #include "Config_var.h"

    #undef CFG_AMOUNT
    #undef CFG_ANGLE
    #undef CFG_COUNT
    #undef CFG_BOOL
    #undef CFG_STRING

    double kickable_area;

public:
    CConfig();
	virtual ~CConfig()
	{
		Clear();
	}

    void Load(
		const string &sFilename, 
		const char cSeparator = ':'
	);
    void AssignValues();

	KPDL_RESULT Clear()
	{
		m_cConfigMap.clear();
		return KPDL_SUCCESS;
	}

    // Transformacne funkcie
	string GetString(
		const string &sID, 
		const string &sValue = ""
	);
    
	double GetAmount(
		const string &sID, 
		const double dValue = INVALID_AMOUNT
	);
	
	double GetAngle(
		const string &sID, 
		const double dValue = INVALID_ANGLE
	);
    
	int GetCount(
		const string &sID, 
		const int iValue = INVALID_COUNT
	);
    
	bool GetBool(
		const string &sID, 
		const bool bValue = false
	);

};

#endif // _CONFIG_
