/******************************************************************************
Ak chceme ulozit nejaku hodnotu z konfiguracneho suboru
priamo do premennej bool, int, double alebo string
(kvoli rychlejsiemu pristupu), treba sem pridat makro
CFG_AMOUNT() - desatinna kladna hodnota,
CFG_ANGLE()  - desatinna hodnota vyjadrujuca uhol,
CFG_COUNT()  - celociselny kladny parameter,
CFG_BOOL()   - parameter nadobudajuci dve hodnoty: true / false
               (pouziva sa aj na hodnoty on / off, resp. yes / no)             
CFG_STRING() - retazec znakov
Potom bude premenna s danym nazvom verejne pristupna
premenna triedy CConfig a po zavolani metody
AssignValues() sa tymto premennym priradi hodnota.

//! treba vyriesit zaporne desatinne cisla - nemal by to byt typ AMOUNT,
// pretoze je len pre kladne desatinne hodnoty, ani ANGLE, pretoze je urceny
// pre uhly (navyse vsetky uhly su v hracovi jednotne konvertovane na radiany)
******************************************************************************/

/*****************************************************************************/
// application config
CFG_BOOL(app_autoconnect, false);
CFG_BOOL(app_goalie, false);
CFG_BOOL(app_autoconnect_dummy, false);
CFG_STRING(app_connect_server, "localhost");
CFG_COUNT(app_connect_port, 6000);
CFG_STRING(app_team_name, "KPDL");
CFG_STRING(app_protocol, "7.00");

CFG_BOOL(log_parser, false);
CFG_BOOL(log_system, false);
CFG_BOOL(log_connect, false);

CFG_BOOL(vis_percept, false);
CFG_BOOL(vis_ball, false);
CFG_BOOL(vis_teammate, false);
CFG_BOOL(vis_enemy, false);
CFG_BOOL(vis_player, false);

/*****************************************************************************/
// server.conf - nastavenie servera
CFG_AMOUNT(goal_width, 14.02);
CFG_AMOUNT(player_size, 0.3);
CFG_AMOUNT(player_decay, 0.4);
CFG_AMOUNT(player_rand, 0.1);
CFG_AMOUNT(player_weight, 60.0);
CFG_AMOUNT(player_speed_max, 1.0);
CFG_AMOUNT(player_accel_max, 1.0);

CFG_AMOUNT(stamina_max, 4000.0);
CFG_AMOUNT(stamina_inc_max, 45.0);
CFG_AMOUNT(recover_dec_thr, 0.3);
CFG_AMOUNT(recover_dec, 0.002);
CFG_AMOUNT(recover_min, 0.5);

CFG_AMOUNT(effort_dec_thr, 0.3);
CFG_AMOUNT(effort_dec, 0.005);
CFG_AMOUNT(effort_inc_thr, 0.6);
CFG_AMOUNT(effort_inc, 0.01);
CFG_AMOUNT(effort_min, 0.6);

CFG_COUNT(hear_max, 2);
CFG_COUNT(hear_inc, 1);
CFG_COUNT(hear_decay, 2);
CFG_AMOUNT(inertia_moment, 5.0);

CFG_COUNT(slow_down_factor, 1);
CFG_COUNT(send_vi_step, 100 * slow_down_factor);
CFG_COUNT(simulator_step, 100 * slow_down_factor);
CFG_COUNT(send_step, 150 * slow_down_factor);
CFG_COUNT(recv_step, 10);
CFG_COUNT(sense_body_step, 100 * slow_down_factor);
CFG_COUNT(synch_offset, 60 * slow_down_factor);
CFG_COUNT(synch_micro_sleep, 1);
CFG_BOOL(synch_mode, false);
CFG_COUNT(half_time, -1);

CFG_AMOUNT(catchable_area_l, 2.0);
CFG_AMOUNT(catchable_area_w, 1.0);
CFG_AMOUNT(catch_probability, 1.0);
CFG_COUNT(catch_ban_cycle, 5);
CFG_COUNT(goalie_max_moves, 2);

CFG_AMOUNT(ball_size, 0.085);
CFG_AMOUNT(ball_decay, 0.94);
CFG_AMOUNT(ball_rand, 0.05);
CFG_AMOUNT(ball_weight, 0.2);
CFG_AMOUNT(ball_speed_max, 2.7);
CFG_AMOUNT(ball_accel_max, 2.7);

CFG_AMOUNT(wind_force, 0.0);
CFG_ANGLE(wind_dir, DegToRad(0.0));
CFG_AMOUNT(wind_rand, 0.0);
CFG_BOOL(wind_none, false);
CFG_BOOL(wind_random, false);

CFG_AMOUNT(kickable_margin, 0.7);
CFG_AMOUNT(ckick_margin, 1.0);
CFG_AMOUNT(dash_power_rate, 0.006);
CFG_AMOUNT(kick_power_rate, 0.027);
CFG_AMOUNT(kick_rand, 0.0);

CFG_ANGLE(visible_angle, DegToRad(90.0));
CFG_AMOUNT(visible_distance, 3.0);
CFG_AMOUNT(audio_cut_dist, 50.0);

CFG_AMOUNT(quantize_step, 0.1);
CFG_AMOUNT(quantize_step_l, 0.01);
CFG_AMOUNT(quantize_step_dir, 0.1);
CFG_AMOUNT(quantize_step_dist_team_l, quantize_step);
CFG_AMOUNT(quantize_step_dist_team_r, quantize_step);
CFG_AMOUNT(quantize_step_dist_l_team_l, quantize_step_l);
CFG_AMOUNT(quantize_step_dist_l_team_r, quantize_step_l);
CFG_AMOUNT(quantize_step_dir_team_l, quantize_step_dir);
CFG_AMOUNT(quantize_step_dir_team_r, quantize_step_dir);

CFG_AMOUNT(maxpower, 100.0);
CFG_AMOUNT(minpower, -100.0);
CFG_ANGLE(maxmoment, DegToRad(180.0));
CFG_ANGLE(minmoment, DegToRad(-180.0));
CFG_ANGLE(maxneckmoment, DegToRad(180.0));
CFG_ANGLE(minneckmoment, DegToRad(-180.0));
CFG_ANGLE(maxneckang, DegToRad(90.0));
CFG_ANGLE(minneckang, DegToRad(-90.0));

CFG_COUNT(port, 6000);
CFG_COUNT(coach_port, 6001);
CFG_COUNT(olcoach_port, 6002);
CFG_COUNT(say_coach_cnt_max, 128);
CFG_COUNT(say_coach_msg_size, 128);

CFG_COUNT(clang_win_size, 300);
CFG_COUNT(clang_define_win, 1);
CFG_COUNT(clang_meta_win, 1);
CFG_COUNT(clang_advice_win, 1);
CFG_COUNT(clang_info_win, 1);
CFG_COUNT(clang_mess_delay, 50);
CFG_COUNT(clang_mess_per_cycle, 1);

CFG_COUNT(drop_ball_time, 200);
CFG_COUNT(say_msg_size, 512);
CFG_BOOL(use_offside, true);
CFG_AMOUNT(offside_active_area_size, 5.0);
CFG_BOOL(forbid_kick_off_offside, true);
CFG_AMOUNT(offside_kick_margin, 9.15);

CFG_BOOL(team_actuator_noise, false);
CFG_AMOUNT(control_radius, 2.0);

//! tieto parametre su urcene zrejme len soccerserveru
//  implicitne vsetko povypinane 
//  :(aj ked v server.conf bude zrejme nieco aj zapnute)
CFG_BOOL(verbose, false);
CFG_BOOL(log_times, false);
CFG_BOOL(coach, false);
CFG_BOOL(coach_w_referee, false);
CFG_BOOL(old_coach_hear, false);

CFG_STRING(log_file, "");
CFG_STRING(record, "");
CFG_BOOL(record_messages, false);
CFG_COUNT(record_version, 2);
CFG_BOOL(record_log, false);
CFG_BOOL(send_log, false);
CFG_STRING(replay, "");

//! tieto parametre by mali byt v nasej konfiguracii
//  z pohladu home - opponent 
CFG_AMOUNT(prand_factor_l, 1.0);
CFG_AMOUNT(prand_factor_r, 1.0);
CFG_AMOUNT(kick_rand_factor_l, 1.0);
CFG_AMOUNT(kick_rand_factor_r, 1.0);
CFG_COUNT(start_goal_l, 0);
CFG_COUNT(start_goal_r, 0);
CFG_BOOL(fullstate_l, false);
CFG_BOOL(fullstate_r, false);
CFG_AMOUNT(slowness_on_top_for_left_team, 1.0);
CFG_AMOUNT(slowness_on_top_for_right_team, 1.0);

/*****************************************************************************/
// parametre 'zakompilovane' v serveri, 
// ktore sa nenachadzaju v konfiguracnom subore
CFG_AMOUNT(field_length, 52.5);
CFG_AMOUNT(field_width, 34.0);
CFG_AMOUNT(field_margin, 5.0);
CFG_AMOUNT(penalty_area_length, 16.5);
CFG_AMOUNT(penalty_area_width, 20.16);
CFG_AMOUNT(unum_far_length, 20.0);
CFG_AMOUNT(unum_too_far_length, 40.0);
CFG_AMOUNT(team_far_length, 40.0);
CFG_AMOUNT(team_too_far_length, 60.0);
CFG_AMOUNT(extra_stamina, 0.0);
CFG_AMOUNT(effort_max, 1.0);

CFG_AMOUNT(center_circle_r, 9.15);
CFG_COUNT(max_player, 11);

/*
// nasledujuce parametre sme 'vydolovali'  zo zdrojakov servera
// nie su uvedene v dokumentacii k serveru, nenacitavaju sa
// konfiguracneho suboru a ani nemaju standardizovany identifikator

// tieto sme uz v istej (prisposobenej) forme pouzili
//PITCH_LENGTH          105.0
//PITCH_WIDTH           68.0
//PITCH_MARGIN          5.0
//PENALTY_AREA_LENGTH   16.5
//PENALTY_AREA_WIDTH    40.32
//CENTER_CIRCLE_R       9.15
//MAX_PLAYER            11

// dalsie parametre ihriska
GOAL_AREA_LENGTH        5.5
GOAL_AREA_WIDTH         18.32
GOAL_DEPTH              2.44

// miscelaneous mix
PENALTY_SPOT_DIST       11.0
CORNER_ARC_R            1.0
KICK_OFF_CLEAR_DISTANCE CENTER_CIRCLE_R
WIND_WEIGHT             10000.0
AFTER_GOAL_WAIT         50
AFTER_OFFSIDE_WAIT      30

// odvodene parametre aj s predpisom na ich vypocet
// (podobne ako kickable_area); treba zvazit ich pouzitie
cotrol_radius_width = control_radius - player_size;
lcm_step = 
	Lcm(simulator_step, 
		Lcm(send_step, 
			Lcm(recv_step, 
				Lcm(sense_body_step, send_vi_step)
	)	)	);
lcm_step = Lcm(lcm_st, (synch_mode)? synch_offset : 1); 
*/

/*****************************************************************************/
// player.conf - nastavenia pre heterogennych hracov
CFG_COUNT(player_types, 7);
CFG_COUNT(subs_max, 3);
CFG_COUNT(pt_max, 3);
CFG_AMOUNT(player_speed_max_delta_min, 0.0);
CFG_AMOUNT(player_speed_max_delta_max, 0.2);
CFG_AMOUNT(stamina_inc_max_delta_factor, -100.0);
CFG_AMOUNT(player_decay_delta_min, 0.0);
CFG_AMOUNT(player_decay_delta_max, 0.2);
CFG_AMOUNT(inertia_moment_delta_factor,	25.0);
CFG_AMOUNT(dash_power_rate_delta_min, 0.0);
CFG_AMOUNT(dash_power_rate_delta_max, 0.002);
CFG_AMOUNT(player_size_delta_factor, -100.0);
CFG_AMOUNT(kickable_margin_delta_min, 0.0);
CFG_AMOUNT(kickable_margin_delta_max, 0.2);
CFG_AMOUNT(kick_rand_delta_factor, 0.5);
CFG_AMOUNT(extra_stamina_delta_min, 0.0);
CFG_AMOUNT(extra_stamina_delta_max, 100.0);
CFG_AMOUNT(effort_max_delta_factor, -0.002);
CFG_AMOUNT(effort_min_delta_factor, -0.002);
CFG_COUNT(random_seed, -1);
