//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	GameTime.h
 *  \brief Implementacia triedy hracich casov 
 *  \author KPDL
 *  \date
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//******************************************************
/*! \fn	string CGameTime::GetAttribute(const string &sName) const
 *  \brief Vracia pozadovanu clensku premennu (atribut) hracieho casu ako retazec
 *  \param const string &sName
 *  \return Clensku premennu hracieho casu
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
string CGameTime::GetAttribute(const string &sName) const
{
	char sBuffer[QUERY_MAX_BUFFER] = QUERY_NOT_AVAILABLE;

	//-------------------------------------------------------
	// allCycles
	//-------------------------------------------------------
	if(sName == "allCycles")
		sprintf(sBuffer, "%d", iAllCycles);

	//-------------------------------------------------------
	// playTime
	//-------------------------------------------------------
	else if(sName == "playTime")
		sprintf(sBuffer, "%d", iPlayTime);

	//-------------------------------------------------------
	// playMode
	//-------------------------------------------------------
	else if(sName == "playMode")
		sprintf(
			sBuffer, 
			(ePlayMode == PM_BeforeKickOff) ? "before_kick_off" :
			(ePlayMode == PM_TimeOver) ? "time_over" :
			(ePlayMode == PM_PlayOn) ? "play_on" :
			(ePlayMode == PM_KickOff_Home) ? "kick_off_home" :
			(ePlayMode == PM_KickOff_Opponent) ? "kick_off_opponent" :
			(ePlayMode == PM_KickIn_Home) ? "kick_in_home" :
			(ePlayMode == PM_KickIn_Opponent) ? "kick_in_opponent" :
			(ePlayMode == PM_FreeKick_Home) ? "free_kick_home" :
			(ePlayMode == PM_FreeKick_Opponent) ? "free_kick_opponent" :
			(ePlayMode == PM_CornerKick_Home) ? "corner_kick_home" :
			(ePlayMode == PM_CornerKick_Opponent) ? "corner_kick_opponent" :
			(ePlayMode == PM_GoalKick_Home) ? "goal_kick_home" :
			(ePlayMode == PM_GoalKick_Opponent) ? "goal_kick_opponent" :
			"other"
		);

	return string(sBuffer);
}