//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	SystemClock.cpp
 *  \brief Implementacia triedy systemovych hodin
 *  \author KPDL
 *  \date
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//******************************************************
/*! \fn	KPDL_RESULT CSystemClock::Initialize()
 *  \brief Inicializuje systemove hodiny
 *  \return KPDL_SUCCESS / KPDL_ERROR
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
KPDL_RESULT CSystemClock::Initialize()
{
    LARGE_INTEGER tValue;

    if(!QueryPerformanceFrequency(&tValue))
		return KPDL_ERROR;

	m_iCountsPerSec = tValue.QuadPart;

	if(!QueryPerformanceCounter(&tValue))
		return KPDL_ERROR;

	m_iInitCount = tValue.QuadPart;

	return KPDL_SUCCESS;
}

//******************************************************
/*! \fn	TSystemTime CSystemClock::GetTime()
 *  \brief Vracia aktualny systemovy cas
 *  \return Aktualny systemovy cas
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
TSystemTime CSystemClock::GetTime()
{
    LARGE_INTEGER tValue;

	if(!QueryPerformanceCounter(&tValue))
		return INVALID_TIME;

    return (int)(
		((__int64) tValue.QuadPart - m_iInitCount) * 1000 / m_iCountsPerSec
	);
}