//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	Communicator.h
 *  \brief Deklaracia triedy komunikatorov
 *  \author KPDL
 *  \date
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef _COMMUNICATOR_
#define _COMMUNICATOR_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CCommunicator : public CEventThread
{
	DECLARE_EVENT_MAP

private:		
	CConnection m_cConnection;		// spojenie so serverom
    CTranslator m_cTranslator;		// prekladac sprav
	CSystemClock m_cSystemClock;	// systemove hodiny 
	CGameTime m_cGameTime;			// hraci cas
    
    int m_iForceSystemTime;
    bool m_bSynchWasStop;

public:
    CCommunicator(CCoordinator &cCoordinator);
	
	KPDL_RESULT OnConnect(CEvent &cEvent);
	KPDL_RESULT OnDisconnect(CEvent &cEvent);
	KPDL_RESULT OnReceiveMsg(CEvent &cEvent);
	KPDL_RESULT OnAct(CEvent &cEvent);

	void UpdateGameTime(const CPerception &pPerception);
};

#endif // _COMMUNICATOR_
	