//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	Connection.h
 *  \brief Deklaracia triedy spojovacov so serverom
 *  \author KPDL
 *  \date
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef _CONNECTION_
#define _CONNECTION_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CCommunicator;

class CConnection : public CAsyncSocket
{
private:
	SOCKADDR_IN m_tSockAddr;		// adresa socketa na komunikaciu so serverom
	CSystemClock &m_cSystemClock;	// systemove hodiny
	CCommunicator &m_cCommunicator;	// nadradeny komunikator

public:
    CConnection(
		CSystemClock &cSystemClock, 
		CCommunicator &cCommunicator
	);

    KPDL_RESULT Connect(const string &sHostAddress, const int iHostPort);
    KPDL_RESULT Send(CServerMsg& cMsg);

	//{{AFX_VIRTUAL(CConnection)
	public:
	virtual void OnReceive(int nErrorCode);
	//}}AFX_VIRTUAL
};

#endif // _CONNECTION_
