//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	GameCommand.cpp
 *  \brief Implementacia triedy prikazov pre server
 *  \author KPDL
 *  \date
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//******************************************************
/*! \fn	CGameCommand::CGameCommand()
 *  \brief Konstruktor triedy
 *  \return
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
CGameCommand::CGameCommand()
{
	eGameCommand = GC_None;
}

//******************************************************
/*! \fn	CGameCommand::CGameCommand(const CGameTime cTime)
 *  \brief Konstruktor triedy
 *  \param const CGameTime cTime
 *  \return
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
/*CGameCommand::CGameCommand(const CGameTime cTime)
{
	cGameTime = cTime; 
	eGameCommand = GC_None;
}*/

//******************************************************
/*! \fn	void CGameCommand::Catch(double direction)
 *  \brief Nastavi prikaz na typ "catch"
 *  \param double direction
 *  \return
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
void CGameCommand::Catch(double direction)
{
	eGameCommand = GC_Catch;
	dArg1 = direction;
}

//******************************************************
/*! \fn	void CGameCommand::ChangeView(EViewWidthType width, EViewQualityType quality)
 *  \brief Nastavi prikaz na typ "change_view"
 *  \param EViewWidthType width
 *  \param EViewQualityType quality
 *  \return
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
void CGameCommand::ChangeView(EViewWidthType width, EViewQualityType quality)
{
	eGameCommand = GC_ChangeView; 
	switch(width) {
		case VW_Narrow:
			sArg1 = "narrow";
			break;
		case VW_Normal:
			sArg1 = "normal";
			break;
		case VW_Wide:
			sArg1 = "wide";
			break;
		default:
			sArg1 = "none";
	}

	switch(quality) {
		case VQ_Low:
			sArg2 = "low";
			break;
		case VQ_High:
			sArg2 = "high";
			break;
		default:
			sArg2 = "none";
	}
}

//******************************************************
/*! \fn	void CGameCommand::Dash(double power)
 *  \brief Nastavi prikaz na typ "dash"
 *  \param double power
 *  \return
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
void CGameCommand::Dash(double power)
{
	eGameCommand = GC_Dash;
	dArg1 = power;
}

//******************************************************
/*! \fn	void CGameCommand::Kick(double power, double dir)
 *  \brief Nastavi prikaz na typ "kick"
 *  \param double power
 *  \param double dir
 *  \return
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
void CGameCommand::Kick(double power, double dir)
{
	eGameCommand = GC_Kick;
	dArg1 = power;
	dArg2 = dir;
}

//******************************************************
/*! \fn	void CGameCommand::Move(double x, double y)
 *  \brief Nastavi prikaz na typ "move"
 *  \param double x
 *  \param double y
 *  \return
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
void CGameCommand::Move(double x, double y)
{
	eGameCommand = GC_Move;
	dArg1 = x;
	dArg2 = y;
}

//******************************************************
/*! \fn	void CGameCommand::Say(string message)
 *  \brief Nastavi prikaz na typ "say"
 *  \param string message
 *  \return
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
void CGameCommand::Say(string message)
{
	eGameCommand = GC_Say;
	sArg1 = message;
}

//******************************************************
/*! \fn	void CGameCommand::Turn(double moment)
 *  \brief Nastavi prikaz na typ "turn"
 *  \param double moment
 *  \return
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
void CGameCommand::Turn(double moment)
{
	eGameCommand = GC_Turn;
	dArg1 = moment;
}

//******************************************************
/*! \fn	void CGameCommand::TurnNeck(double angle)
 *  \brief Nastavi prikaz na typ "turn_neck"
 *  \param double angle
 *  \return
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
void CGameCommand::TurnNeck(double angle)
{
	eGameCommand = GC_TurnNeck;
	dArg1 = angle;
}