//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	GameCommandSeq.cpp
 *  \brief Implementacia triedy sekvencii prikazov pre server
 *  \author KPDL
 *  \date
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//******************************************************
/*! \fn	CGameCommandSeq::~CGameCommandSeq()
 *  \brief Destruktor triedy
 *  \return
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
CGameCommandSeq::~CGameCommandSeq()
{
	Clear();	// vymaze rad
}

//******************************************************
/*! \fn	KPDL_RESULT CGameCommandSeq::AddGameCommand(CGameCommand *pGameCommand) 
 *  \brief Prida novy prikaz do radu prikazov
 *  \param CGameCommand *pGameCommand
 *  \return KPDL_SUCCESS
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
KPDL_RESULT CGameCommandSeq::AddGameCommand(CGameCommand *pGameCommand) 
{
	cGameCommandQueue.push(pGameCommand);

	return KPDL_SUCCESS;
}

//******************************************************
/*! \fn	KPDL_RESULT CGameCommandSeq::GetGameCommand(CGameCommand **ppGameCommand)
 *  \brief Vybera prvy prikaz z radu prikazov a vracia ukazovatel na neho (po pouziti prikazu treba uvolnit pamat!)
 *  \param CGameCommand **ppGameCommand
 *  \return KPDL_SUCCESS / KPDL_UNSUCCESS
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
KPDL_RESULT CGameCommandSeq::GetGameCommand(CGameCommand **ppGameCommand)
{
	if(cGameCommandQueue.size() > 0){
		*ppGameCommand = cGameCommandQueue.front();
		cGameCommandQueue.pop();
		
		return KPDL_SUCCESS;	// podarilo sa vybrat pointer z radu
	}
	
	return KPDL_UNSUCCESS;		// rad je prazdny
}

//******************************************************
/*! \fn	int CGameCommandSeq::GetGameCommandsCount()
 *  \brief Vracia velkost radu prikazov 
 *  \return Velkost radu prikazov
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
int CGameCommandSeq::GetGameCommandsCount()
{
	return cGameCommandQueue.size();
}

//******************************************************
/*! \fn	KPDL_RESULT CGameCommandSeq::Clear()
 *  \brief Vymaze rad prikazov pre server 
 *  \return KPDL_SUCCESS
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
KPDL_RESULT CGameCommandSeq::Clear()
{
    while( !cGameCommandQueue.empty() ){
        delete cGameCommandQueue.front();
        cGameCommandQueue.pop();
    }

	return KPDL_SUCCESS;
}