//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	GameTime.h
 *  \brief Deklaracia triedy hracich casov 
 *  \author KPDL
 *  \date
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef _GAME_TIME_
#define _GAME_TIME_

class CGameTime
{
public:
	int iPlayTime;				// pocet odohranych cyklov
	int iStopCycles;			// pocet zastavenych cyklov
	int iAllCycles;				// celkovy pocet cyklov
	EPlayModeType ePlayMode;	// hraci mod

public:
    CGameTime(const int iCycles = 0)
	:	iPlayTime(0),
		iStopCycles(0),
		iAllCycles(iCycles),
		ePlayMode(PM_None)
	{
	}

    void operator ++ ()
	{ 
		iAllCycles++;
	}

    bool operator < (const CGameTime &a) const 
	{ 
		return (iAllCycles <  a.iAllCycles); 
	}
    
	bool operator <= (const CGameTime &a) const 
	{ 
		return (iAllCycles <= a.iAllCycles);
	}

    bool operator > (const CGameTime &a) const
	{ 
		return (iAllCycles >  a.iAllCycles); 
	}
    
	bool operator >= (const CGameTime &a) const
	{ 
		return (iAllCycles >= a.iAllCycles); 
	}
    
	bool operator == (const CGameTime &a) const
	{ 
		return (iAllCycles == a.iAllCycles);
	}

    bool operator < (const int a) const
	{ 
		return (iAllCycles < a);
	}
    
	bool operator <= (const int a) const
	{ 
		return (iAllCycles <= a);
	}
    
	bool operator > (const int a) const
	{ 
		return (iAllCycles > a);
	}
    
	bool operator >= (const int a) const
	{
		return (iAllCycles >= a);
	}

    bool operator == (const int a) const
	{
		return (iAllCycles == a);
	}

	// implementacia rozhrania CQuery
	virtual string GetAttribute(const string &sName) const;
};

inline bool operator < (const int a, const CGameTime &b) 
{ 
	return (a < b.iAllCycles);
}

inline bool operator <=	(const int a, const CGameTime &b)
{
	return (a <= b.iAllCycles);
}

inline bool operator > (const int a, const CGameTime &b)
{
	return (a > b.iAllCycles);
}

inline bool operator >=	(const int a, const CGameTime &b)
{
	return (a >= b.iAllCycles);
}

inline bool operator ==	(const int a, const CGameTime &b)
{
	return (a == b.iAllCycles);
}

#endif  // _GAME_TIME_