//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	HearMsg.cpp
 *  \brief Implementacia triedy vnemov typu "hear"
 *  \author KPDL
 *  \date
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//******************************************************
/*! \fn	CHearMsg::CHearMsg()
 *  \brief Konstruktor triedy
 *  \return
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
CHearMsg::CHearMsg()
:	CPerception(M_Hear),
	eHearMsg(HM_None),
	ePlayMode(PM_None),
	sMessage(""),
	dDirection(INVALID_ANGLE)
{
}

//******************************************************
/*! \fn	CHearMsg::CHearMsg(const CHearMsg &cSource)
 *  \brief Kopirovaci konstruktor triedy
 *  \param const CHearMsg &cSource
 *  \return
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
CHearMsg::CHearMsg(const CHearMsg &cSource)
:	CPerception(cSource),
	eHearMsg(cSource.eHearMsg),
	ePlayMode(cSource.ePlayMode),
	sMessage(cSource.sMessage),
	dDirection(cSource.dDirection)
{
}

//******************************************************
/*! \fn	KPDL_RESULT CHearMsg::Parse(CTranslator &cTranslator, CParseString &cString)
 *  \brief Parsuje vnem
 *  \param CTranslator &cTranslator
 *  \param CParseString &cString
 *  \return KPDL_SUCCESS
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
KPDL_RESULT CHearMsg::Parse(
	CTranslator &cTranslator, 
	CParseString &cString
)
{
	CParseString cWord;

	if(cString.GetWord(cWord) == KPDL_SUCCESS)
		iPlayTime = cWord.GetInteger();

	if(cString.GetWord(cWord) == KPDL_SUCCESS)
		eHearMsg = cTranslator.CountHearMsgType(cWord);

	switch(eHearMsg)
	{
		case HM_Referee:
			if(cString.GetWord(cWord) == KPDL_SUCCESS)
				ePlayMode = cTranslator.CountPlayModeType(cWord);
			cString.GetRest(sMessage);
			break;

		case HM_Other:
			dDirection = ANGLE(cWord.GetDouble());
		case HM_Self:
		case HM_OnlineCoachHome:
		case HM_OnlineCoachOpponent:
			cString.GetRest(sMessage);
			break;
	}

	return KPDL_SUCCESS;
}

//******************************************************
/*! \fn	const CHearMsg &CHearMsg::operator =(const CHearMsg &cSource)
 *  \brief Operator priradenia
 *  \param const CHearMsg &cSource
 *  \return Referenciu na aktualny objekt
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
const CHearMsg &CHearMsg::operator =(const CHearMsg &cSource)
{
	CPerception::operator =(cSource);

	eHearMsg = cSource.eHearMsg;
	ePlayMode = cSource.ePlayMode;
	sMessage = cSource.sMessage;
	dDirection = cSource.dDirection;

	return *this;
}