//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	InitMsg.cpp
 *  \brief Implementacia triedy vnemov typu "init"
 *  \author KPDL
 *  \date
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//******************************************************
/*! \fn	CInitMsg::CInitMsg()
 *  \brief Konstruktor triedy
 *  \return
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
CInitMsg::CInitMsg()
:	CPerception(M_Init),
	ePlayMode(PM_None),
	eRealSide(RS_None),
	iNumber(INVALID_COUNT)
{
}

//******************************************************
/*! \fn	CInitMsg::CInitMsg(const CInitMsg &cSource)
 *  \brief Kopirovaci konstruktor triedy
 *  \param const CInitMsg &cSource
 *  \return
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
CInitMsg::CInitMsg(const CInitMsg &cSource)
:	CPerception(cSource),
	ePlayMode(cSource.ePlayMode),
	eRealSide(cSource.eRealSide),
	iNumber(cSource.iNumber)
{
}

//******************************************************
/*! \fn	KPDL_RESULT CInitMsg::Parse(CTranslator &cTranslator, CParseString &cString)
 *  \brief Parsuje vnem
 *  \param CTranslator &cTranslator
 *  \param CParseString &cString
 *  \return KPDL_SUCCESS
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
KPDL_RESULT CInitMsg::Parse(
	CTranslator &cTranslator, 
	CParseString &cString
)
{
	CParseString cWord;

	if(cString.GetWord(cWord) == KPDL_SUCCESS)
		eRealSide = cTranslator.CountRealSideType(cWord);

	if(cString.GetWord(cWord) == KPDL_SUCCESS)
		iNumber = cWord.GetInteger();
	
	if(cString.GetWord(cWord) == KPDL_SUCCESS)
		ePlayMode = cTranslator.CountPlayModeType(cWord);

	return KPDL_SUCCESS;
}

//******************************************************
/*! \fn	const CInitMsg &CInitMsg::operator =(const CInitMsg &cSource)
 *  \brief Operator priradenia
 *  \param const CInitMsg &cSource
 *  \return Referenciu na aktualny objekt
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
const CInitMsg &CInitMsg::operator =(const CInitMsg &cSource)
{
	CPerception::operator =(cSource);

	ePlayMode = cSource.ePlayMode;
	eRealSide = cSource.eRealSide;
	iNumber = cSource.iNumber;

	return *this;
}	