//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	ParseString.cpp
 *  \brief Implementacia triedy analyzovanych retazcov
 *  \author KPDL
 *  \date
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//******************************************************
/*! \fn	KPDL_RESULT CParseString::GetWord(CParseString &cWord)
 *  \brief Vracia spravu z analyzovaneho retazca
 *  \param CParseString &cWord
 *  \return KPDL_SUCCESS / KPDL_UNSUCCESS
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
KPDL_RESULT CParseString::GetWord(CParseString &cWord)
{
	cWord = "";
	int iSize = m_sString.size();

	if(m_iPosition >= iSize)
		return KPDL_UNSUCCESS;

	while(
		(!isalnum(m_sString[m_iPosition])) && (m_sString[m_iPosition] != '-') &&
		(m_sString[m_iPosition] != '_') && (m_iPosition < iSize)
	)
	{
		m_iPosition++;
	}

	int iStart = m_iPosition;

	while(
		((isalnum(m_sString[m_iPosition])) || (m_sString[m_iPosition] == '.') ||
		(m_sString[m_iPosition] == '-') || (m_sString[m_iPosition] == '_')) && 
		(m_iPosition < iSize)
	)
	{
		m_iPosition++;
	}
	
	cWord = m_sString.substr(iStart, m_iPosition - iStart);

	while(m_sString[m_iPosition] == '"')
	{
		m_iPosition++;
	}

	return KPDL_SUCCESS;
}

//******************************************************
/*! \fn	KPDL_RESULT CParseString::GetBar(CParseString &cBar)
 *  \brief Vracia zatvorku z analyzovaneho retazca
 *  \param CParseString &cBar
 *  \return KPDL_SUCCESS / KPDL_UNSUCCESS
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
KPDL_RESULT CParseString::GetBar(CParseString &cBar)
{
	int iSize = m_sString.size();
	int iLevel = 0;

	if(m_iPosition >= iSize)
		return KPDL_UNSUCCESS;

	while((m_sString[m_iPosition] != '(') && (m_iPosition < iSize))
	{
		m_iPosition++;
	}

	if(m_iPosition < iSize)
		m_iPosition++;
	
	int iStart = m_iPosition;

	while(
		((m_sString[m_iPosition] != ')') || (iLevel != 0)) && 
		(m_iPosition < iSize)
	) 
	{
		if(m_sString[m_iPosition] == '(')
			iLevel++;
		else if(m_sString[m_iPosition] == ')')
			iLevel--;

		m_iPosition++;
	}

	//! myslim, ze test na koniec retazca by mal byt vykonany
	// skor s iStart (ako s m_iPosition)
	if(m_iPosition < iSize)
	{
		cBar = m_sString.substr(iStart, m_iPosition - iStart);
		return KPDL_SUCCESS;
	}

	cBar = "";
	return KPDL_UNSUCCESS;
}

//******************************************************
/*! \fn	KPDL_RESULT CParseString::GetRest(string &sWord)
 *  \brief Vracia zvysok z analyzovaneho retazca
 *  \param string &sWord
 *  \return KPDL_SUCCESS / KPDL_UNSUCCESS
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
KPDL_RESULT CParseString::GetRest(string &sWord)
{
	int iSize = m_sString.size();

	sWord = "";
	if(m_iPosition >= iSize)
		return KPDL_UNSUCCESS;

	sWord = m_sString.substr(m_iPosition);
	m_iPosition = iSize;

	return KPDL_SUCCESS;
}