//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	ParseString.h
 *  \brief Deklaracia triedy analyzovanych retazcov
 *  \author KPDL
 *  \date
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef _PARSE_STRING_
#define _PARSE_STRING_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CParseString
{
private:
	string m_sString;	// analyzovany retazec	
	int m_iPosition;	// aktualna pozicia v retazci

public:
	CParseString() : m_sString(""), m_iPosition(0) {}
	CParseString(const string &sString) : m_sString(sString), m_iPosition(0) {}

	KPDL_RESULT GetWord(CParseString &cWord);
	KPDL_RESULT GetBar(CParseString &cBar);
	KPDL_RESULT GetRest(string &sWord);

	int GetInteger()
	{
		return atoi(m_sString.c_str() + m_iPosition);
	}

	double GetDouble()
	{
		return atof(m_sString.c_str() + m_iPosition);
	}

	bool operator ==(const CParseString &cParseString) const
	{
		return m_sString == cParseString.m_sString;
	}

	bool operator ==(const string &sString) const
	{
		return m_sString == sString;
	}

	bool operator ==(const char *sString) const
	{
		return m_sString == sString;
	}

	const CParseString &operator =(const CParseString &cParseString)
	{	
		m_sString = cParseString.m_sString;
		m_iPosition = cParseString.m_iPosition;
		return *this;
	}

	const CParseString &operator =(const string &sString)
	{
		m_sString = sString;
		m_iPosition = 0;
		return *this;
	}	

	const CParseString &operator =(const char *sString)
	{
		m_sString = sString;
		m_iPosition = 0;
		return *this;
	}

	operator const char() const
	{
		// vratime prvy znak retazca 
		return *(m_sString.c_str());
	}
};

#endif // _PARSE_STRING_
