//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	SeeMsg.cpp
 *  \brief Implementacia triedy vnemov typu "see"
 *  \author KPDL
 *  \date
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//******************************************************
/*! \fn	CSeeMsg::CSeeMsg()
 *  \brief Konstruktor triedy
 *  \return
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
CSeeMsg::CSeeMsg()
:	CPerception(M_See),
	cPlayers(),
	cFlags(),
	cLines(),
	cGoals(),
	cBall()
{
}

//******************************************************
/*! \fn	CSeeMsg::CSeeMsg(const CSeeMsg &cSource)
 *  \brief Kopirovaci konstruktor triedy
 *  \param const CSeeMsg &cSource
 *  \return
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
CSeeMsg::CSeeMsg(const CSeeMsg &cSource)
:	CPerception(cSource),
	cPlayers(cSource.cPlayers),
	cFlags(cSource.cFlags),
	cLines(cSource.cLines),
	cGoals(cSource.cGoals),
	cBall(cSource.cBall)
{
}

//******************************************************
/*! \fn	CSeeMsg::~CSeeMsg()
 *  \brief Destruktor triedy
 *  \return
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
CSeeMsg::~CSeeMsg()
{
	cPlayers.clear();
	cFlags.clear();
	cLines.clear();
	cGoals.clear();
}

//******************************************************
/*! \fn	KPDL_RESULT CSeeMsg::Parse(CTranslator &cTranslator, CParseString &cString)
 *  \brief Parsuje vnem
 *  \param CTranslator &cTranslator
 *  \param CParseString &cString
 *  \return KPDL_SUCCESS
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
KPDL_RESULT CSeeMsg::Parse(
	CTranslator &cTranslator, 
	CParseString &cString
)
{
	CParseString cWord;
	CParseString cName;
	CParseString cBody;
	CSeenObject *pObject = NULL;
	char cChar;

	if(cString.GetWord(cWord) == KPDL_SUCCESS)
		iPlayTime = cWord.GetInteger();

	while(cString.GetBar(cBody) == KPDL_SUCCESS)
	{
		if(cBody.GetBar(cName) != KPDL_SUCCESS ||
			cName.GetWord(cWord) != KPDL_SUCCESS
		)
			continue;

		cChar = cWord;
		pObject =
			(cChar == 'l') ? 
				(CSeenObject *) cLines.insert(cLines.end()) :
			(cChar == 'F' || cChar == 'f') ? 
				(CSeenObject *) cFlags.insert(cFlags.end()) :
			(cChar == 'P' || cChar == 'p') ? 
				(CSeenObject *) cPlayers.insert(cPlayers.end()) :
			(cChar == 'G' || cChar == 'g') ? 
				(CSeenObject *) cGoals.insert(cGoals.end()) :
			(cChar == 'B' || cChar == 'b') ? 
				(CSeenObject *) &cBall :
			NULL;

		if(pObject != NULL)
			pObject->Parse(cTranslator, cName, cBody);
	}

	return KPDL_SUCCESS;
}

//******************************************************
/*! \fn	const CSeeMsg &CSeeMsg::operator =(const CSeeMsg &cSource)
 *  \brief Operator priradenia
 *  \param const CSeeMsg &cSource
 *  \return Referenciu na aktualny objekt
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
const CSeeMsg &CSeeMsg::operator =(const CSeeMsg &cSource)
{
	CPerception::operator =(cSource);

	cPlayers = cSource.cPlayers;
	cFlags = cSource.cFlags;
	cGoals = cSource.cGoals;
	cLines = cSource.cLines;
	cBall = cSource.cBall;

	return *this;
}