//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	SeenFlag.h
 *  \brief Trieda videnych zastavok
 *  \author KPDL
 *  \date
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef _SEEN_FLAG_
#define _SEEN_FLAG_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CSeenFlag;

typedef vector<CSeenFlag> TSeenFlagVector;
typedef TSeenFlagVector::iterator TSeenFlagVectorIterator;

class CSeenFlag : public CSeenObject
{
public:
	EFlagType eFlag;	// typ zastavky

public:
    CSeenFlag(const EFlagType eFlag = F_None)
	:	CSeenObject(),
		eFlag(eFlag)
	{
	}

    CSeenFlag(const CSeenFlag &cSource)
	:	CSeenObject(cSource),
		eFlag(cSource.eFlag)
	{
	}

	KPDL_RESULT Parse(
		CTranslator &cTranslator, 
		CParseString &cName,
		CParseString &cBody
	)
	{
		CParseString cWord;
		char cChar1 = '\0';
		char cChar2 = '\0';
		char cChar3 = '\0';

		if(cName.GetWord(cWord) == KPDL_SUCCESS)
			cChar1 = cWord;
		if(cName.GetWord(cWord) == KPDL_SUCCESS)
			cChar2 = cWord;
		if(cName.GetWord(cWord) == KPDL_SUCCESS)
			cChar3 = cWord;

		eFlag = cTranslator.CountFlagType(cChar1, cChar2, cChar3);
		
		return CSeenObject::Parse(cTranslator, cName, cBody);
	}

    const CSeenFlag &operator =(const CSeenFlag &cSource)
	{
		CSeenObject::operator =(cSource);
		eFlag = cSource.eFlag;

		return *this;
	}
};

#endif // _SEEN_FLAG_
