//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	SeenGoal.h
 *  \brief Trieda videnych branok
 *  \author KPDL
 *  \date
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef _SEEN_GOAL_
#define _SEEN_GOAL_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CSeenGoal;

typedef vector<CSeenGoal> TSeenGoalVector;
typedef TSeenGoalVector::iterator TSeenGoalVectorIterator;

class CSeenGoal : public CSeenObject
{
public:
	EGoalType eGoal;	// typ branky

public:
    CSeenGoal(const EGoalType eGoal = G_None)
	:	CSeenObject(),
		eGoal(eGoal)
	{
	}

	CSeenGoal(const CSeenGoal &cSource)
	:	CSeenObject(cSource),
		eGoal(cSource.eGoal)
	{
	}

	KPDL_RESULT Parse(
		CTranslator &cTranslator, 
		CParseString &cName,
		CParseString &cBody
	)
	{
		CParseString cWord;

		if(cName.GetWord(cWord) == KPDL_SUCCESS)
			eGoal = cTranslator.CountGoalType(cWord);

		return CSeenObject::Parse(cTranslator, cName, cBody);
	}

    const CSeenGoal &operator = (const CSeenGoal &cSource)
	{
		CSeenObject::operator =(cSource);
		eGoal = cSource.eGoal;

		return *this;
	}
};

#endif // _SEEN_GOAL_