//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	SeenLine.h
 *  \brief Trieda videnych ciar
 *  \author KPDL
 *  \date
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef _SEEN_LINE_
#define _SEEN_LINE_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CSeenLine;

typedef vector<CSeenLine> TSeenLineVector;
typedef TSeenLineVector::iterator TSeenLineVectorIterator;

class CSeenLine : public CSeenObject
{
public:
	ELineType eLine;	// typ ciary

public:
    CSeenLine(const ELineType eLine = L_None)
	:	CSeenObject(),
		eLine(eLine)
	{
	}

    CSeenLine(const CSeenLine &cSource)
	:	CSeenObject(cSource),
		eLine(cSource.eLine)
	{
	}

	KPDL_RESULT Parse(
		CTranslator &cTranslator, 
		CParseString &cName,
		CParseString &cBody
	)
	{
		CParseString cWord;

		if(cName.GetWord(cWord) == KPDL_SUCCESS)
			eLine = cTranslator.CountLineType(cWord);

		return CSeenObject::Parse(cTranslator, cName, cBody);
	}

	const CSeenLine &operator = (const CSeenLine &cSource)
	{
		CSeenObject::operator =(cSource);
		eLine = cSource.eLine;

		return *this;
	}
};

#endif // _SEEN_LINE_