//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	SeenObject.cpp
 *  \brief Implementacia zakladnej triedy videnych objektov
 *  \author KPDL	
 *  \date
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//******************************************************
/*! \fn	CSeenObject::CSeenObject()
 *  \brief Konstruktor triedy
 *  \return
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
CSeenObject::CSeenObject()
:	dDistance(INVALID_AMOUNT),
	dDirection(INVALID_ANGLE),
	dDistanceChange(INVALID_AMOUNT),
	dDirectionChange(INVALID_ANGLE)
{
}

//******************************************************
/*! \fn	CSeenObject::CSeenObject(const CSeenObject &cSource)
 *  \brief Kopirovaci konstruktor triedy
 *  \param const CSeenObject &cSource
 *  \return
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
CSeenObject::CSeenObject(const CSeenObject &cSource)
:	dDistance(cSource.dDistance),
	dDirection(cSource.dDirection),
	dDistanceChange(cSource.dDistanceChange),
	dDirectionChange(cSource.dDirectionChange)
{
}

//******************************************************
/*! \fn	KPDL_RESULT CSeenObject::Parse(CTranslator &cTranslator, CParseString &cName, CParseString &cBody)
 *  \brief Parsuje videny objekt
 *  \param CTranslator &cTranslator 
 *  \param CParseString &cName
 *  \param CParseString &cBody
 *  \return KPDL_SUCCESS
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
KPDL_RESULT CSeenObject::Parse(
	CTranslator &cTranslator,
	CParseString &cName,
	CParseString &cBody
)
{
	CParseString cWord;

	if(cBody.GetWord(cWord) == KPDL_SUCCESS)
		dDistance = cWord.GetDouble();

	if(cBody.GetWord(cWord) == KPDL_SUCCESS)
		dDirection = ANGLE(cWord.GetDouble());

	if(cBody.GetWord(cWord) == KPDL_SUCCESS)
		dDistanceChange = cWord.GetDouble();

	if(cBody.GetWord(cWord) == KPDL_SUCCESS)
		dDirectionChange = ANGLE(cWord.GetDouble());

	return KPDL_SUCCESS;
}

//******************************************************
/*! \fn	const CSeenObject &CSeenObject::operator =(const CSeenObject &cSource) 
 *  \brief Operator priradenia
 *  \param const CSeenObject &cSource
 *  \return Referenciu na aktualny objekt
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
const CSeenObject &CSeenObject::operator =(const CSeenObject &cSource) 
{
	dDistance = cSource.dDistance; 
	dDirection = cSource.dDirection; 
	dDistanceChange = cSource.dDistanceChange; 
	dDirectionChange = cSource.dDirectionChange;

	return *this;
}