//+++++++++++++++++++++	+++++++++++++++++++++++++++++++++
/*! \file	SeenObject.h
 *  \brief Deklaracia zakladnej triedy videnych objektov
 *  \author KPDL
 *  \date
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef _SEEN_OBJECT_
#define _SEEN_OBJECT_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CSeenObject
{
public:
	double dDistance;			// vzdialenost
	double dDirection;			// smer
	double dDistanceChange;		// zmena vzdialenosti
	double dDirectionChange;	// zmena smeru	

public:
    CSeenObject();
	CSeenObject(const CSeenObject &cSource);

	bool IsValid() const		
	{
		return (
			IsValidAmount(dDistance) || 
			IsValidAngle(dDirection) ||
			IsValidAmount(dDistanceChange) || 
			IsValidAngle(dDirectionChange)
		);
	}

	virtual KPDL_RESULT Parse(
		CTranslator &cTranslator, 
		CParseString &cName,
		CParseString &cBody
	);

	const CSeenObject &operator =(const CSeenObject &cSource);
};

#endif // _SEEN_OBJECT_