//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	SeenPlayer.cpp
 *  \brief Implementacia triedy videnych hracov
 *  \author KPDL
 *  \date
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//******************************************************
/*! \fn	CSeenPlayer::CSeenPlayer()
 *  \brief Konstruktor triedy
 *  \return
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
CSeenPlayer::CSeenPlayer()
:	CSeenObject(),
	eSide(S_None),
	iNumber(INVALID_COUNT),
	dBodyDirection(INVALID_ANGLE),
	dHeadDirection(INVALID_ANGLE)
{
}

//******************************************************
/*! \fn	CSeenPlayer::CSeenPlayer(const CSeenPlayer &cSource)
 *  \brief Kopirovaci konstruktor triedy
 *  \param const CSeenPlayer &cSource
 *  \return
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
CSeenPlayer::CSeenPlayer(const CSeenPlayer &cSource)
:	CSeenObject(cSource),
	eSide(cSource.eSide),
	iNumber(cSource.iNumber),
	dBodyDirection(cSource.dBodyDirection),
	dHeadDirection(cSource.dHeadDirection)
{
}

//******************************************************
/*! \fn	KPDL_RESULT CSeenPlayer::Parse(CTranslator &cTranslator, CParseString &cName, CParseString &cBody)
 *  \brief Parsuje videneho hraca
 *  \param CTranslator &cTranslator
 *  \param CParseString &cName
 *  \param CParseString &cBody
 *  \return KPDL_SUCCESS
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
KPDL_RESULT CSeenPlayer::Parse(
	CTranslator &cTranslator, 
	CParseString &cName,
	CParseString &cBody
)
{
	CParseString cWord;

	// oznacenie hraca
	if(cName.GetWord(cWord) == KPDL_SUCCESS)
		eSide = cTranslator.CountSideType(cWord);

	if(cName.GetWord(cWord) == KPDL_SUCCESS)
		iNumber = cWord.GetInteger();

	// relativne parametre
	CSeenObject::Parse(cTranslator, cName, cBody);

	if(cBody.GetWord(cWord) == KPDL_SUCCESS)
		dBodyDirection = ANGLE(cWord.GetDouble()); //! t0n0 bolo tu - !!!

	if(cBody.GetWord(cWord) == KPDL_SUCCESS)
		dHeadDirection = ANGLE(cWord.GetDouble());

	return KPDL_SUCCESS;
}

//******************************************************
/*! \fn	const CSeenPlayer &CSeenPlayer::operator =(const CSeenPlayer &cSource)
 *  \brief Operator priradenia
 *  \param const CSeenPlayer &cSource
 *  \return	Referenciu na aktualny objekt
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
const CSeenPlayer &CSeenPlayer::operator =(const CSeenPlayer &cSource)
{
	CSeenObject::operator =(cSource);

	eSide = cSource.eSide;
	iNumber = cSource.iNumber;
	dBodyDirection = cSource.dBodyDirection;
	dHeadDirection = cSource.dHeadDirection;

	return *this;
}	