//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	SeenPlayer.h
 *  \brief Deklaracia triedy videnych hracov
 *  \author KPDL
 *  \date
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef _SEEN_PLAYER_
#define _SEEN_PLAYER_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CSeenPlayer;

typedef vector<CSeenPlayer> TSeenPlayerVector;
typedef TSeenPlayerVector::iterator TSeenPlayerVectorIterator;

class CSeenPlayer : public CSeenObject
{
public:
	ESideType eSide;		// typ hraca - spoluhrac / protihrac
	int	iNumber;			// cislo hraca
	double dBodyDirection;	// smer tela hraca
	double dHeadDirection;	// smer hlavy hraca

public:
    CSeenPlayer();
    CSeenPlayer(const CSeenPlayer &cSource);

	KPDL_RESULT Parse(
		CTranslator &cTranslator, 
		CParseString &cName,
		CParseString &cBody
	);

    const CSeenPlayer &operator =(const CSeenPlayer &cSource);
};

#endif // _SEEN_PLAYER_
