//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	Translator.h
 *  \brief Deklaracia triedy prekladacov sprav a prikazov hraca	 
 *  \author KPDL
 *  \date
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef _TRANSLATOR_
#define _TRANSLATOR_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CPerception;

class CTranslator
{
private:
	ERealSideType m_eRealSide;	// skutocna strana, na ktorej hra hrac
	string m_sTeamName;			// nazov timu hraca

public:
	CTranslator();

	CPerception *ParseServerMsg(const CServerMsg &cServerMsg);
	KPDL_RESULT GenerateServerMsg(
		const CGameCommand &cGameCommand, 
		CServerMsg &cServerMsg
	);

	// konverzia retazcov na hodnoty vymenovanych typov
	ERealSideType CountRealSideType(const char cChar);
	EHearMsgType CountHearMsgType(const CParseString &cString);
	EViewQualityType CountViewQualityType(const CParseString &cString);
	double CountViewWidth(const CParseString &cString);
	ESideType CountSideType(const CParseString &cString);
	EFlagType CountFlagType(
		const char cChar1, 
		const char cChar2, 
		const char cChar3
	);
	EGoalType CountGoalType(const char cChar);
	ELineType CountLineType(const char cChar);
	EPlayModeType CountPlayModeType(const CParseString &cParseString);
};

#endif  // _TRANSLATOR_
