// Decisions.cpp: implementation of the CDecisions class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

BEGIN_EVENT_MAP(CDecisions)
	ADD_EVENT(E_Decide, CDecisions::OnDecide)
END_EVENT_MAP

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDecisions::CDecisions(CCoordinator &cCoordinator, CStaticField &cField)
:	CEventThread(cCoordinator, THREAD_PRIORITY_NORMAL),
	m_cWorld(cField),
	m_cActions(),
	m_cSkillList(),
	m_cStrategicSkills(m_cWorld, m_cSkillList, "strategy.xml"),
	m_cReactiveSkills(
		m_cWorld, 
		m_cActions, 
		m_cSkillList, 
		m_cStrategicSkills, 
		"rules.xml"
	)
{
}

KPDL_RESULT CDecisions::OnDecide(CEvent &cEvent)
{    
	m_cWorld = ((CDecideEvent &)cEvent).cWorld;
	m_cStrategicSkills.Deliberate();

	m_cReactiveSkills.Deliberate();
	if(!m_cSkillList.IsEmpty()) 
	{
		m_cSkillList.EvaluateAndRemove();
	}

	CEvent *pEvent = new CActEvent(m_cActions);
	GenerateEvent(pEvent);
	pEvent->Release();

	m_cActions.Clear();
	return KPDL_SUCCESS;
}
