
#include "stdAfx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//////////////////////////////////////////////////////////////////////////////////
// Class CFormation
//////////////////////////////////////////////////////////////////////////////////

CFormation::CFormation()
{
}


CFormation::~CFormation()
{
}

CTeamPosition *CFormation::GetPosition(Pnum num)
{
	return &(PositionList[num]); 
}

Pnum CFormation::LocationToPosition(C2DVector p)
{
	/* Finds the position whose home range (x,y) falls.  If more than one,
	takes the one closest to the home position.  If none, takes the one
	whose home range rectangle is closest */
	
	Pnum position = 0;
	/*
	double tiebreakDist = -1000;  
	
	CRectangle *HomeRange;
	
	for (int i=1; i<=GetSize(); i++)
	{
		HomeRange = GetPosition(i)->GetHomeRange();
		if ( HomeRange->IsIn(p) )
		{  			double HomeDist = DistanceToPositionHome(i,p);
			if ( tiebreakDist < 0 || HomeDist < tiebreakDist )
			{
				position = i;
				tiebreakDist = HomeDist;
			}
		}
		else if ( tiebreakDist < 0 && HomeRange->DistanceToEdge(p) > tiebreakDist )
		{
			position = i;
			tiebreakDist = HomeRange->DistanceToEdge(p);
		}
	}
	*/
	return position;
}

double CFormation::DistanceToPositionHome(Pnum position, C2DVector p)
{
	C2DVector Home = GetPosition(position)->GetHome();
	return (Home-p).GetDistance();
}

Pnum CFormation::ClosestPosition(C2DVector p)
{
	double dist, minDist = HUGE;
	Pnum closestPosition;
	for (int position=1; position<=m_size; position++)
	{
		dist = DistanceToPositionHome(position,p);
		if (dist < minDist)
		{
			minDist = dist;
			closestPosition = position;
		}
	}
	return closestPosition;
}

C2DVector CFormation::GetHomePosition(Pnum PlayerNumber)
{
	return GetPosition(PlayerNumber)->GetHome();
}

Ptype CFormation::GetActualPlayerType(Pnum PlayerNumber)
{
	return PositionList[PlayerNumber].GetType();
}

KPDL_RESULT CFormation::SetXML(IXMLDOMNodePtr &pNode)
{
	_variant_t vValue;
	IXMLDOMNodeListPtr pChildList;
	IXMLDOMNodePtr pChild;
	
	//
	// read attributes
	//
	pNode->attributes->getNamedItem("name")->get_nodeValue(&vValue);
	m_name = _bstr_t(vValue);
	
	pNode->attributes->getNamedItem("offset")->get_nodeValue(&vValue);
	sFormationType = _bstr_t(vValue);
	
	//
	// read positions
	//
	pChildList = pNode->selectNodes(L"position");
	pChildList->reset();
	
	pChildList->get_length( &m_size );
	
	while((pChild = pChildList->nextNode()) != NULL)
	{
		//cCond.SetXML(pChild);
		//cCondList.push_back(cCond);
		string tmp;
		long pnum, ptype;
		double xhome, yhome, radius;
		
		pChild->attributes->getNamedItem("pid")->get_nodeValue(&vValue);
		pnum = (long)vValue;
		
		pChild->attributes->getNamedItem("x")->get_nodeValue(&vValue);
		tmp = _bstr_t(vValue);
		xhome = atof( tmp.c_str() );
		
		pChild->attributes->getNamedItem("y")->get_nodeValue(&vValue);
		tmp = _bstr_t(vValue);
		yhome = atof( tmp.c_str() );
		
		pChild->attributes->getNamedItem("radius")->get_nodeValue(&vValue);
		tmp = _bstr_t(vValue);
		radius = atof( tmp.c_str() );

		pChild->attributes->getNamedItem("ptype")->get_nodeValue(&vValue);
		ptype = (long)vValue;
		
		//ajajajaj....
		
		PositionList[pnum].SetHome(C2DVector(xhome,yhome),radius,(enum Ptype) ptype);
	}
	
	
	return KPDL_SUCCESS;
}

string CFormation::GetAttribute( const string& sName )
{
	string sHeader = sName;
	string sTail = SplitTail( sHeader );

	if ( sName == "name" )
		return m_name;

	return string(QUERY_NOT_AVAILABLE);
}