#ifndef _FORMATION_H
#define _FORMATION_H


class CFormation;

typedef map<string, CFormation*> TFormationMap;
typedef TFormationMap::iterator TFormationMapIterator;

//////////////////////////////////////////////////////////////////////////////////
//                             Formation Class                                    
//////////////////////////////////////////////////////////////////////////////////
class CFormation : public CQuery
{
private:
	string	 m_name;
	long	 m_size;

	
	CTeamPosition PositionList[MAX_PLAYERS]; 

public:
	string	 sFormationType;

public:
	CFormation();
	~CFormation();
	
	inline int GetSize() { return m_size; }
	inline const string& GetName() { return m_name; }

	CTeamPosition *GetPosition(Pnum num);
	
	// 
	bool IsMoreImportantPosition(Pnum pos1, Pnum pos2);
	Pnum   LocationToPosition(C2DVector p);
	double DistanceToPositionHome(Pnum position, C2DVector p);
	Pnum   ClosestPosition(C2DVector p);
	C2DVector GetHomePosition(Pnum PlayerNumber);

	CRectangle *GetMyHomeRange(Pnum PlayerNumber);
	Ptype GetActualPlayerType(Pnum PlayerNumber);

	// Serialization
	KPDL_RESULT SetXML(IXMLDOMNodePtr &pNode);	

	// CQuery
	string GetAttribute( const string& sName );

};

#endif // _FORMATION_H