// StrategicSkills.h: interface for the CStrategicSkills class.
//
//////////////////////////////////////////////////////////////////////

#ifndef __STRATEGICSKILLS_H
#define __STRATEGICSKILLS_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef map<string,string> TVariableMap;

class CStrategicSkills : public CQuery
{
	DECLARE_TERM_MAP

private:
	TVariableMap m_VarMap;
	CFormation* m_pFormation;
	CFormationData m_cFormationData;
	CRuleEngine m_cRuleEngine;
	CWorldModel &m_cWorld;
	CBasicSkillList& m_cBasicSkillList;

	EPlayModeType m_PlayMode;

public:
	CStrategicSkills( CWorldModel& cWorld, CBasicSkillList& cBasicSkillList, const string &sFileName );
	virtual ~CStrategicSkills();

	void Deliberate();

	void Variable( const string& sVarName, string& sVarValue );

	// termy
	string ActionPosition();
	string StrategicPosition();

	string playerType();
	string playModeChanged();

	// CQuery
	string GetAttribute(const string &sName);
	void ClearCache();

private:
	void UpdateVariables();
	
};

#endif // __STRATEGICSKILLS_H_
