// Coordinator.h: interface for the CCoordinator class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _COORDINATOR_
#define _COORDINATOR_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CEventThread;

typedef set<CEventThread *> TThreadSet;
typedef TThreadSet::iterator TThreadSetIterator;

// Mozno by nebolo odveci spravit thread aj z koordinatora
// zjednodusil by sa prechod na singlethreadoveho hraca
// Minimalne by mal byt koordinator (vlastne event dispatcher)
// implementovany thread safe
class CCoordinator  
{
protected:
	TThreadSet m_cThreadSet;

public:
	CCoordinator() {}
	virtual ~CCoordinator()
	{
		m_cThreadSet.clear();
	}

	KPDL_RESULT DispatchEvent(CEvent &cEvent);

	KPDL_RESULT RegisterEventThread(CEventThread &cThread)
	{
		m_cThreadSet.insert(&cThread);
		// RadoK
		return KPDL_SUCCESS;
	}

	KPDL_RESULT UnregisterEventThread(CEventThread &cThread)
	{
		m_cThreadSet.erase(&cThread);
		// RadoK
		return KPDL_SUCCESS;
	}
    
};

#endif // _COORDINATOR_
