// Event.h: interface for the CEvent and derived classes
//
//////////////////////////////////////////////////////////////////////

#ifndef _EVENT_
#define _EVENT_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CEvent  
{
public:
	EEventType eType;

private:
	long m_lRefCount;

public:
	CEvent(const EEventType eType = E_None)
	:	eType(eType),
		m_lRefCount(1l)
	{
	}
	virtual ~CEvent() {}
	
	long AddRef()
	{
		return InterlockedIncrement(&m_lRefCount);
	}

	long Release()
	{
		long lNewCount = InterlockedDecrement(&m_lRefCount);
		if(lNewCount == 0l)
			delete this;

		return lNewCount;
	}
};

#endif // _EVENT_
