// EventThread.cpp : implementation file
//

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BEGIN_MSG_MAP(CEventThread)
	ADD_MSG(WM_EVENT, OnEventMessage)
END_MSG_MAP

BEGIN_EVENT_MAP(CEventThread)
END_EVENT_MAP

// Mechanizmus na namapovanie 
KPDL_RESULT CEventThread::OnEventMessage(
	const WPARAM wParam, 
	const LPARAM lParam
)
{
	if(lParam == NULL)
		return KPDL_ERROR;

	SEventMap *pEntry;
	CEvent &cEvent = *(CEvent *)lParam;
	KPDL_RESULT eResult = KPDL_UNSUCCESS;

	for(pEntry = GetEventMap(); pEntry->fnEvent != NULL; pEntry++)
	{
		if(pEntry->eType == cEvent.eType)
		{
			// Tento release je priradeny k AddRef v metode SetEvent()
			eResult = (this->*pEntry->fnEvent)(cEvent);
			cEvent.Release();
			return eResult;
		}
	}

	// Tento release je priradeny k AddRef v metode SetEvent()
	cEvent.Release();
	return eResult;
}

