// LogFrame.cpp : implementation of the CChildFrame class
//

#include "stdafx.h"
#include "resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLogFrame

IMPLEMENT_DYNCREATE(CLogFrame, CMDIChildWnd)

BOOL CLogFrame::PreCreateWindow(CREATESTRUCT& tCS)
{
	if(!CMDIChildWnd::PreCreateWindow(tCS))
		return FALSE;

	m_hIcon = LoadIcon(AfxGetResourceHandle(), MAKEINTRESOURCE(IDR_MAINFRAME));
	tCS.style = WS_CHILD | WS_VISIBLE | WS_OVERLAPPEDWINDOW | WS_MAXIMIZE;
	tCS.lpszName = LOG_WINDOW_NAME;
	tCS.lpszClass = AfxRegisterWndClass(
		CS_VREDRAW | CS_VREDRAW | CS_OWNDC, NULL, NULL, m_hIcon
	);
	tCS.dwExStyle &= ~WS_EX_CLIENTEDGE;

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CChildFrame message handlers

BEGIN_MESSAGE_MAP(CLogFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CLogFrame)
		ON_WM_CREATE()
		ON_WM_DESTROY()
		ON_WM_SETFOCUS()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

int CLogFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if(CMDIChildWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// create a view to occupy the client area of the frame
	if(!m_cLogView.Create(
		NULL, 
		NULL, 
		AFX_WS_DEFAULT_VIEW, 
		CRect(0, 0, 0, 0), 
		this, 
		AFX_IDW_PANE_FIRST, 
		NULL
	))
	{
		if(gpSystemLog != NULL)
			gpSystemLog->Write(
				true,
				"Chyba: Nepodarilo sa vytvorit okno s logovacimi vypismi!"
			);

		return -1;
	}

	return 0;
}

void CLogFrame::OnDestroy() 
{
	CMDIChildWnd::OnDestroy();
	
	if(m_hIcon != NULL)
		DestroyIcon(m_hIcon);
}

void CLogFrame::OnSetFocus(CWnd* pOldWnd) 
{
	CMDIChildWnd::OnSetFocus(pOldWnd);
	m_cLogView.SetFocus();
}

BOOL CLogFrame::OnCmdMsg(
	UINT nID, 
	int nCode, 
	void* pExtra, 
	AFX_CMDHANDLERINFO* pHandlerInfo
) 
{
	// let the view have first crack at the command
	if(m_cLogView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;
	
	// otherwise, do default handling
	return CMDIChildWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}
