// LogManager.h: interface for the CLogManager class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _LOG_MANAGER_
#define _LOG_MANAGER_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// informacna polozka kazdeho suboru
struct SFileEntry
{
	// handle na otvoreny subor
	FILE* hFileHnd;
	// kolkokrat je subor otvoreny
	ULONG ulRefCount;
};

typedef map<string, SFileEntry> TFileMap;
typedef TFileMap::iterator TFileMapIterator;

class CLogManager
{
public:
	// referencia na masku zobrazovanych sprav
	ELogMask &eLogMask;
	// buffer sprav
	CLogBuffer cLogBuffer;
	// okno, ktore zobrazuje logy
	CLogView *pLogView;

private:
	// zoznam nazvov suborov, handle a poctov referencii
	TFileMap m_cFileMap;
	// casova peciatka spustenia hraca
	// (vsetky casy su voci nej relativne)
	ULONG m_ulRefTimeStamp;

public:
	CLogManager(
		ELogMask &eLogMask,
		CLogView *pLogView = NULL
	);
	virtual ~CLogManager();

	KPDL_RESULT Open(
		const string &sFileName, 
		const string &sFileMode
	);
	KPDL_RESULT Close(const string &sFileName);
	KPDL_RESULT Write(
		const string &sFileName,
		const ELogMask eMsgMask,
		const bool bTimeStamp,
		const char* sMessage
	);
};

#endif // _LOG_MANAGER_
