// CLogView.cpp : implementation file
//

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLogView

CLogView::CLogView()
:	m_cDevice(),
	m_cBitmap(),
	m_cFont()
{
	// Singleton
	if(gpLogManager != NULL)
		gpLogManager->pLogView = this;
}

CLogView::~CLogView()
{
	if(gpLogManager != NULL)
		gpLogManager->pLogView = NULL;
}

BOOL CLogView::Create(
	LPCTSTR lpszClassName, 
	LPCTSTR lpszWindowName, 
	DWORD dwStyle, 
	const RECT& rect, 
	CWnd* pParentWnd, 
	UINT nID, 
	CCreateContext* pContext
) 
{	
	BOOL bRetVal = CWnd::Create(
		lpszClassName, 
		lpszWindowName, 
		dwStyle, 
		rect, 
		pParentWnd, 
		nID, 
		pContext
	);

	CClientDC cClientDC(this);
	m_cDevice.CreateCompatibleDC(&cClientDC);
	m_cBitmap.CreateCompatibleBitmap(
		&cClientDC, 
		::GetSystemMetrics(SM_CXSCREEN),
		::GetSystemMetrics(SM_CYSCREEN)
	); 
	m_cDevice.SetMapMode(MM_TEXT);
	m_cFont.CreateFont(
		LOG_FONT_SIZE, 0, 0, 0, FW_DONTCARE,
		FALSE, FALSE, FALSE, ANSI_CHARSET, 
		OUT_DEVICE_PRECIS, CLIP_DEFAULT_PRECIS, 
		DEFAULT_QUALITY, DEFAULT_PITCH, LOG_FONT_NAME
	);
	m_cDevice.SelectObject(&m_cFont);
	return bRetVal;
}

BOOL CLogView::PreCreateWindow(CREATESTRUCT& tCS) 
{
	if(!CWnd::PreCreateWindow(tCS))
		return FALSE;

	tCS.dwExStyle |= WS_EX_CLIENTEDGE;
	tCS.style &= ~WS_BORDER;
	tCS.lpszClass = AfxRegisterWndClass(
		CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW),
		HBRUSH(COLOR_WINDOW+1),
		NULL
	);
	
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CLogView message handlers

BEGIN_MESSAGE_MAP(CLogView, CWnd)
	//{{AFX_MSG_MAP(CLogView)
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CLogView::OnEraseBkgnd(CDC* pDevice) 
{
	return FALSE;
}

void CLogView::OnPaint() 
{
	CPaintDC cDevice(this);
	CRect cRectUpd;

	cDevice.GetClipBox(&cRectUpd);

	//CBitmap* pOldBitmap = 
	m_cDevice.SelectObject(&m_cBitmap);
	m_cDevice.SelectClipRgn(0);
	m_cDevice.IntersectClipRect(&cRectUpd);

	CBrush cBkgndBrush((COLORREF)::GetSysColor(COLOR_WINDOW));
	//CBrush* pOldBrush = 
	m_cDevice.SelectObject(&cBkgndBrush);
	m_cDevice.PatBlt(
		cRectUpd.left, 
		cRectUpd.top, 
		cRectUpd.Width(), 
		cRectUpd.Height(), 
		PATCOPY
	);

	if(gpLogManager != NULL)
		gpLogManager->cLogBuffer.Show(
			m_cDevice, 
			m_cViewSize.y, 
			LOG_FONT_SIZE
		);

	cDevice.BitBlt(
		cRectUpd.left, 
		cRectUpd.top, 
		cRectUpd.Width(), 
		cRectUpd.Height(), 
		&m_cDevice, 
		cRectUpd.left, 
		cRectUpd.top, 
		SRCCOPY
	);

//	m_cDevice.SelectObject(pOldBitmap);
//	m_cDevice.SelectObject(pOldBrush);
}

void CLogView::OnSize(UINT uiType, int iX, int iY) 
{
	m_cViewSize.x = iX;
	m_cViewSize.y = iY;
}
