//*****************************************************************************
// Forward.h: interface of the CForwardNetwork class
//*****************************************************************************

#ifndef _FORWARD_
#define _FORWARD_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//*****************************************************************************
class CForwardNetwork : public CNeuralNetwork
{
// Members
public:
	// Limits
	int iSizeIn;
	int iSizeHid;
	int iSizeOut;

private:
	// Layers
	CLayer m_cHidLayer;
	CLayer m_cOutLayer;
	// Temporals
	CVector m_cHidden;

// Methods
public:
	CForwardNetwork(
		const int iInputSize,
		const int iHiddenSize,
		const int iOutputSize,
		CActivate &cActivate,
		const double dTolerance = 0.1,
		const double dMomentum = 0.0,
		const double dAlpha = 0.0
	);
	virtual ~CForwardNetwork(){}

	KPDL_RESULT Process(CSymbol &cInput, CSymbol &cOutput);
	double Adapt(CSymbol &cInput, CSymbol &cDesired);

};

#endif // _FORWARD_
