//*****************************************************************************
// Layer.h: interface of the CLayer class
//*****************************************************************************

#ifndef _LAYER_
#define _LAYER_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//*****************************************************************************
// Just an interface
class CLayer : public CItem
{
// Members
public:
	// Limits
	int iSizeIn;
	int iSizeOut;

protected:
	// Weights
	CMatrix m_cWeights;
	// Weight updates
	CMatrix m_cDiffW;
	// Activation function
	CActivate &m_cActivate;

// Methods
public:
	CLayer::CLayer(
		const int iSizeIn,
		const int iSizeOut,
		CActivate &cActivate
	);
	virtual ~CLayer() {}

	KPDL_RESULT OutputDelta(
		CVector &cDesired,
		CVector &cOutput,
		CVector &cDelta
	);

	KPDL_RESULT HiddenDelta(
		CVector &cDeltaIn,
		CVector &cOutput,
		CVector &cDelta
	);

	KPDL_RESULT Adapt(
		const double dAlpha,
		const double dMomentum,
		CVector &cDelta,
		CVector &cInput
	);
	
	KPDL_RESULT Process(
		CVector &cInput, 
		CVector &cOutput
	);
};

#endif // _LAYER_
