//*****************************************************************************
// FILE:         List.h
// DESCRIPTION:  Generic list & list item class
// PROJECT:      Evolution as an avalanche process
// AUTHOR:       Anton Weissensteiner
// DATE:         5.11.2001
//*****************************************************************************

#ifndef _KPDL_LIST_
#define _KPDL_LIST_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CItem  
{
// Members
public:
	CItem *pPrev;
	CItem *pNext;

// Methods
public:
	CItem();
	virtual ~CItem();

	KPDL_RESULT AddPrev(CItem *pNew);
	KPDL_RESULT AddNext(CItem *pNew);
	CItem *GetFirst();
	CItem *GetLast();

	bool IsFirst()
	{
		return pPrev == NULL;
	}

	bool IsLast()
	{
		return pNext == NULL;
	}
};

class CList  
{
// Members
private:
	CItem *m_pCurrent;
	int m_iSize;

// Methods
public:
	CList();
	virtual ~CList();
	
	KPDL_RESULT Insert(CItem *pNew);
	KPDL_RESULT Append(CItem *pNew);
	KPDL_RESULT Delete();
	KPDL_RESULT Clear();

	KPDL_RESULT MovePrev();
	KPDL_RESULT MoveNext();
	KPDL_RESULT MoveFirst();
	KPDL_RESULT MoveLast();

	bool Contains(CItem *pItem);

	bool IsEmpty()
	{
		return m_pCurrent == NULL;
	}

	CItem *Item()
	{
		return m_pCurrent;
	}

	int GetSize()
	{
		return m_iSize;
	}
};

#endif // _KPDL_LIST_
