//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	NeuralLog.cpp
 *  \brief	Implementacia bazovej triedy logovacich vypisov hraca
 *  \author t0n0 Weissensteiner & Mato Spal
 *  \date 26.2.2002 22:43:41
 *  \version 1.0
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CNeuralLog *gpNeuralLog = NULL;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CNeuralLog::CNeuralLog(
	const string &sFileName, 
	const ELogMask eMsgMask, /* = LOG_MASK_NEURAL */
	const string &sFileMode /* = LOG_ACCESS_MODE_W */
)
:	CLog(sFileName, eMsgMask, sFileMode)
{
}

KPDL_RESULT CNeuralLog::WriteMatrix(
	const bool bTimeStamp,
	const char *sFormat,
	CMatrix &cMatrix
)
{
	static char sBuffer[NEURAL_MAX_BUFFER];
	int iBufLen = 0;
	int iColumn;
	int iRow;

	for(iRow = 0; iRow < cMatrix.iHeight; iRow ++)
	{
		for(iColumn = 0; iColumn < cMatrix.iWidth; iColumn ++)
		{
			sprintf(sBuffer + iBufLen, sFormat, cMatrix(iRow, iColumn));
			iBufLen = strlen(sBuffer);
		}

		if(Write(bTimeStamp, sBuffer) == KPDL_ERROR)
			return KPDL_ERROR;
	}

	return KPDL_SUCCESS;
}

KPDL_RESULT CNeuralLog::WriteVector(
	const bool bTimeStamp,
	const char *sFormat,
	CVector &cVector
)
{
	static char sBuffer[NEURAL_MAX_BUFFER];
	int iBufLen = 0;
	int iIndex;

	for(iIndex = 0; iIndex < cVector.iSize; iIndex ++)
	{
		sprintf(sBuffer + iBufLen, sFormat, cVector(iIndex));
		iBufLen = strlen(sBuffer);
	}

	return Write(bTimeStamp, sBuffer);
}
