#ifndef _NEURON_
#define _NEURON_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CNeuralNetwork
{
// Members
public:
	// Just common configuration
	double dTolerance;
	double dMomentum;
	double dAlpha;

// Memthods
public:
	CNeuralNetwork(
		const double dTolerance = 0.1, 
		const double dMomentum = 0.0, 
		const double dAlpha = 0.0
	);
	virtual ~CNeuralNetwork(){}

	virtual KPDL_RESULT Process(CSymbol &cInput, CSymbol &cOutput) = 0;
	virtual double Adapt(CSymbol &cInput, CSymbol &cDesired) = 0;

	virtual KPDL_RESULT Load(const string &sName) = 0;
	virtual KPDL_RESULT Save(const string &sName) = 0;
};

#endif // _NEURON_