//*****************************************************************************
// Vector.h: interface of the CVector class
//*****************************************************************************

#ifndef _VECTOR_
#define _VECTOR_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//*****************************************************************************
// Vector of real numbers
class CVector : public CItem
{
// Members
public:
	int iSize;

//private:
	static CRandom m_cInitVal;
	double *m_pdStorage;

// Methods
public:
	CVector(
		const int iSize,
		const double dValue = 0.0
	);

	CVector(CVector &cSource);
	
	CVector(
		const int iSize, 
		const double dBottom, 
		const double dTop
	);
	
	virtual ~CVector();

	double Error(CVector &cDesired);

	double &operator ()(const int iIndex);
	CVector &operator =(CVector &cSource);
};

#endif // _VECTOR_
