// Action.cpp: implementation of the CAction class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CAction::CAction()
{
}

CAction::~CAction()
{
	cParamList.clear();
}

KPDL_RESULT CAction::SetXML(IXMLDOMNodePtr &pNode)
{
	_variant_t vValue;
	IXMLDOMNodeListPtr pChildList;
	IXMLDOMNodePtr pChild;
	IXMLDOMNodePtr pAttr;
	CRuleParameter cParam;

	//
	// read attributes
	//
	pNode->attributes->getNamedItem("name")->get_nodeValue(&vValue);
	sName = _bstr_t(vValue);

	//
	// read remove rule
	//
	try
	{
		pNode->attributes->getNamedItem("remove-rule")->get_nodeValue(&vValue);
		sRemoveRule = _bstr_t(vValue);
	}
	catch(_com_error &E)
	{	
		sRemoveRule = "";
	}

	//
	// read parameters
	//
	pChildList = pNode->selectNodes(L"parameters/parameter");
	pChildList->reset();

	while((pChild = pChildList->nextNode()) != NULL)
	{
		cParam.SetXML(pChild);
		cParamList.push_back(cParam);
	}

	return KPDL_SUCCESS;
}
