// Query.cpp: implementation of the CCondition class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BEGIN_TERM_MAP(CQuery)
END_TERM_MAP

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

string CQuery::SplitTail(string &sExpr)
{
	static const int iDelimiterLength = strlen(TERM_DELIMITER);
	int iDelimiter;
	string sTail;

	if(sExpr.empty() ||
		(iDelimiter = sExpr.find_first_of(TERM_DELIMITER)) == sExpr.npos)
		return "";

	sTail = sExpr.substr(iDelimiter + iDelimiterLength);
	sExpr = sExpr.substr(0, iDelimiter);
	return sTail;
}

string CQuery::Evaluate(const string &sTerm)
{
	STermMap *pEntry = NULL;

	// zisti, ci sa term nachadza v cache
	if ( m_cCache.find( sTerm ) != m_cCache.end() )
		return m_cCache[sTerm];

	for(pEntry = GetTermMap(); pEntry->fnTerm != NULL; pEntry++)
	{
		if(sTerm == pEntry->sName)
		{
			string sValue = (this->*pEntry->fnTerm)();
			AddToCache( sTerm, sValue );
			return sValue;
		}
	}

	return GetAttribute(sTerm);
}

string CQuery::GetAttribute(const string &sName)
{
	return QUERY_NOT_AVAILABLE;
}

KPDL_RESULT CQuery::AddToCache( const string& sTerm, const string& sValue )
{
	m_cCache[sTerm] = sValue;
	return KPDL_SUCCESS;
}

