// Query.h: interface for the CQuery class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _QUERY_
#define _QUERY_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CQuery;

typedef string (CQuery::*TTermFunction)();
typedef map<string, string> TValueMap;


struct STermMap
{
	char *sName;
	TTermFunction fnTerm;
};

#define DECLARE_TERM_MAP \
	protected: \
		static STermMap m_tTermMap[]; \
		virtual STermMap * GetTermMap() { return m_tTermMap;}
#define BEGIN_TERM_MAP(class) STermMap class::m_tTermMap[] = {
#define ADD_TERM(sName, fnTerm) {(char *)sName, (TTermFunction)&fnTerm},
#define END_TERM_MAP {NULL, (TTermFunction)NULL}};

class CQuery
{
	DECLARE_TERM_MAP;
	TValueMap m_cCache;

public:
	CQuery() {}
	virtual ~CQuery() {}

	static string SplitTail(string &sExpr);
	virtual string Evaluate(const string &sTerm);
	virtual string GetAttribute(const string &sName);

	virtual void ClearCache() { m_cCache.clear(); };
	KPDL_RESULT AddToCache( const string& sTerm, const string& sValue );
};

#endif // _QUERY_
