// Rule.h: interface for the CRule class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _RULE_
#define _RULE_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CRule;
class CRuleEngine;

typedef vector<CRule *> TRuleVector;
typedef TRuleVector::iterator TRuleVectorIterator;

class CRule : public IXMLNode  
{
public:
	string sName;
	string sPriority;
	TConditionVector cCondList;
	TActionVector cActionList;

private:
	CRuleEngine* m_pParent;

public:
	CRule(CRuleEngine* pParent);
	virtual ~CRule();

	KPDL_RESULT SetXML(IXMLDOMNodePtr &pNode);
	KPDL_RESULT Evaluate(CQuery &cQuery, TActionVector &cResult);
	KPDL_RESULT Evaluate2(CQuery &cQuery, TActionVector &cResult);

};

#endif // _RULE_
