// Player.cpp : implementation of the CPlayer class
//

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPlayer construction/destruction

//------------------------------------------------------
/*! \fn	CPlayer::CPlayer()
 *  \brief Konstruktor, inicializuje jednotlive atributy triedy
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 16:25:38

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
CPlayer::CPlayer()
:	CThread(),
	// vytvorime a prepojime funkcne moduly hraca ...
	cCoordinator(),
	cField(		
		gpConfig->field_length,
		gpConfig->field_width,
		gpConfig->penalty_area_length,
		gpConfig->penalty_area_width,
		gpConfig->goal_width,
		gpConfig->field_margin
	),
	pCommunicator(NULL),
	pWorld(NULL),
	pDecisions(NULL)
{
}

//------------------------------------------------------
/*! \fn	CPlayer::~CPlayer()
 *  \brief destruktor
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 16:25:53

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
CPlayer::~CPlayer()
{
	// v exite sa rusia vsetky clenske premenne,
	// pre istotu to zavolame este raz
	Exit();
}

//------------------------------------------------------
/*! \fn	KPDL_RESULT CPlayer::Init()
 *  \brief Inicialitzuje jednotlive atributy triedy a vytvori ojekty
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 16:31:02

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
KPDL_RESULT CPlayer::Init()
{
	pCommunicator = new CCommunicator(cCoordinator);
	pWorld = new CWorldThread(cCoordinator, cField);
	pDecisions = new CDecisions(cCoordinator, cField);

	CEvent *pEvent = new CConnectEvent();
	pCommunicator->GenerateEvent(pEvent);
	pEvent->Release();

	return KPDL_SUCCESS;
}

//------------------------------------------------------
/*! \fn	void CPlayer::Exit()
 *  \brief Zmaze inicailizovane atributy triedy
 *  \return
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 16:32:16

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
void CPlayer::Exit()
{
	if(pDecisions != NULL)
	{
		delete pDecisions;
		pDecisions = NULL;
	}

	if(pWorld != NULL)
	{
		delete pWorld;
		pWorld = NULL;
	}

	if(pCommunicator != NULL)
	{
		delete pCommunicator;
		pCommunicator = NULL;
	}
}
