//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	playerapp.h
 *  \brief Trieda CPlayerApp tvori samotnu aplikaciu 
	hraca a pouzivatelske rozhranie hraca
 *  \brief Trieda CCmdLineInfo, sluzi na nacitanie prikazovaho riadku
 *  \brief Trieda CAboutDlg, zobrazenie okna o aplikacii
 *  \author Radoslav Otipka 
 *  \date 7.5.2002 16:07:43
 *  \version 

 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef _PLAYER_APP_
#define _PLAYER_APP_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "resource.h"

/////////////////////////////////////////////////////////////////////////////
// aplikacia hrac
class CPlayerApp : public CWinApp
{
private:
	// prihlasenie na server
	bool m_bConnected;
	// konfiguracia ladiacich modulov
	ELogMask m_eLogSetup;
	EVisSetup m_eVisSetup;
	// jeho eminencia hrac
	CPlayer *m_pPlayer;

	// okienka & co...
	HMENU m_hMDIMenu;
	HACCEL m_hMDIAccel;
	CPlayerFrame *m_pPlayerFrame;
	CVisualFrame *m_pVisFrame;
	CLogFrame *m_pLogFrame;

public:
	CPlayerApp();
	virtual ~CPlayerApp();

protected:
	KPDL_RESULT InitGlobals(const string &sConfigName);
	KPDL_RESULT DestroyGlobals();

	//{{AFX_VIRTUAL(CPlayerApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CPlayerApp)
	afx_msg void OnAppAbout();
	afx_msg void OnServerConnect();
	afx_msg void OnUpdateServerConnect(CCmdUI* pCmdUI);
	afx_msg void OnServerConnectGoalie();
	afx_msg void OnUpdateServerConnectGoalie(CCmdUI* pCmdUI);
	afx_msg void OnServerDisconnect();
	afx_msg void OnUpdateServerDisconnect(CCmdUI* pCmdUI);
	afx_msg void OnViewLog();
	afx_msg void OnUpdateViewLog(CCmdUI* pCmdUI);
	afx_msg void OnViewVisualization();
	afx_msg void OnUpdateViewVisualization(CCmdUI* pCmdUI);
	afx_msg void OnSetupVisualization();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// analyzator prikazoveho riadku
class CCmdLineInfo: public CCommandLineInfo
{
public:
    string sAgentCfgName;

public:
    CCmdLineInfo() : sAgentCfgName(PLAYER_DEFAULT_CONF) {}
    
	virtual void ParseParam(
		LPCTSTR lpszParam, 
		BOOL bFlag, 
		BOOL bLast
	)
	{
		// prvy argument, ktory nie je prepinac
		if(!bFlag)
			sAgentCfgName = lpszParam;
	}

};

/////////////////////////////////////////////////////////////////////////////
// dialogove okno about
class CAboutDlg : public CDialog
{
private:
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_sVersion;
	//}}AFX_DATA

public:
	CAboutDlg();

protected:
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
//{{AFX_INSERT_LOCATION}}

#endif // _PLAYER_APP_
