//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	PerceptionSeq.cpp
 *  \brief Implementacia triedy sekvencii vnemov
 *  \author KPDL
 *  \date
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//******************************************************
/*! \fn	CPerceptionSeq::~CPerceptionSeq()
 *  \brief Destruktor triedy
 *  \return
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
CPerceptionSeq::~CPerceptionSeq()
{
	Clear();	// vymaze rad
}

//******************************************************
/*! \fn	KPDL_RESULT CPerceptionSeq::AddPerception(CPerception *pPerception) 
 *  \brief Prida novy vnem do radu vnemov
 *  \param CPerception *pPerception
 *  \return KPDL_SUCCESS
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
KPDL_RESULT CPerceptionSeq::AddPerception(CPerception *pPerception) 
{
	cPerceptionQueue.push(pPerception);

	return KPDL_SUCCESS;
}

//******************************************************
/*! \fn	KPDL_RESULT CPerceptionSeq::GetPerception(CPerception **ppPerception)
 *  \brief Vybera prvy vnem z radu vnemov a vracia ukazovatel na neho (po pouziti vnemu treba uvolnit pamat!)
 *  \param CPerception **ppPerception
 *  \return KPDL_SUCCESS / KPDL_UNSUCCESS
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
KPDL_RESULT CPerceptionSeq::GetPerception(CPerception **ppPerception)
{
	if(cPerceptionQueue.size() > 0){
		*ppPerception = cPerceptionQueue.front();
		cPerceptionQueue.pop();
		
		return KPDL_SUCCESS;	// podarilo sa vybrat pointer z radu
	}
	
	return KPDL_UNSUCCESS;		// rad je prazdny
}

//******************************************************
/*! \fn	KPDL_RESULT CPerceptionSeq::Clear()
 *  \brief Vymaze rad vnemov
 *  \return KPDL_SUCCESS
 *  \author KPDL
 *  \date
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
KPDL_RESULT CPerceptionSeq::Clear()
{ 
	while( !cPerceptionQueue.empty() ){
		delete cPerceptionQueue.front(); 
		cPerceptionQueue.pop();
	}
	
	return KPDL_SUCCESS;
}