// VisualFrame.cpp : implementation of the CVisualFrame class
//

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVisualFrame

IMPLEMENT_DYNCREATE(CVisualFrame, CMDIChildWnd)

BOOL CVisualFrame::PreCreateWindow(CREATESTRUCT& tCS)
{
	if(!CMDIChildWnd::PreCreateWindow(tCS))
		return FALSE;

	m_hIcon = LoadIcon(AfxGetResourceHandle(), MAKEINTRESOURCE(IDR_MAINFRAME));
	tCS.style = WS_CHILD | WS_VISIBLE | WS_OVERLAPPEDWINDOW | WS_MAXIMIZE;
	tCS.lpszName = VIS_WINDOW_NAME;
	tCS.lpszClass = AfxRegisterWndClass(
		CS_VREDRAW | CS_VREDRAW | CS_OWNDC, NULL, NULL, m_hIcon
	);
	tCS.dwExStyle &= ~WS_EX_CLIENTEDGE;

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CVisualFrame message handlers

BEGIN_MESSAGE_MAP(CVisualFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CVisualFrame)
		ON_WM_CREATE()
		ON_WM_DESTROY()
		ON_WM_SETFOCUS()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

int CVisualFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if(CMDIChildWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// create a view to occupy the client area of the frame
	if(!m_cVisualView.Create(
		NULL, 
		NULL, 
		AFX_WS_DEFAULT_VIEW, 
		CRect(0, 0, 0, 0),
		this, 
		AFX_IDW_PANE_FIRST, 
		NULL
	))
	{
		if(gpSystemLog != NULL)
			gpSystemLog->Write(
				true,
				"Chyba: Nepodarilo sa vytvorit vizualizacne okno hraca!"
			);

		return -1;
	}

	return 0;
}

void CVisualFrame::OnDestroy() 
{
	CMDIChildWnd::OnDestroy();
	
	if(m_hIcon != NULL)
		DestroyIcon(m_hIcon);
}

void CVisualFrame::OnSetFocus(CWnd* pOldWnd) 
{
	CMDIChildWnd::OnSetFocus(pOldWnd);
	m_cVisualView.SetFocus();
}

BOOL CVisualFrame::OnCmdMsg(
	UINT nID, 
	int nCode, 
	void* pExtra, 
	AFX_CMDHANDLERINFO* pHandlerInfo
) 
{
	// let the view have first crack at the command
	if (m_cVisualView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;
	
	// otherwise, do default handling
	return CMDIChildWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}
