#ifndef _VIZUALIZE_MAIN_
#define _VIZUALIZE_MAIN_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#pragma warning (disable:4786)

/////////////////////////////////////////////////////////////////////
// External libraries
#include "logmain.h"
#include "worldmain.h"

/////////////////////////////////////////////////////////////////////
// Platform dependent header files
#define VC_EXTRALEAN
#include <afx.h>
#include <afxwin.h>

/////////////////////////////////////////////////////////////////////
// Standard header files

/////////////////////////////////////////////////////////////////////
// Library settings
#define VIS_WINDOW_NAME             "Visualization"

#define VIS_FIELD_LINE_WIDTH        1
#define VIS_FIELD_GOAL_LINE_WIDTH   1
#define VIS_ORIENTED_LINE_SIZE      4

// Okraje
#define VIS_TOP_OFFSET              30
#define VIS_BOTTOM_BORDER           5
#define VIS_LEFT_OFFSET             30
#define VIS_TEXT_INFO_BORDER        30

// Text
#define VIS_TEXT_COLUMN_WIDTH       130
#define VIS_TEXT_FONT_SIZE          15
#define VIS_TEXT_FONT_NAME          "Courier New"

// Magnifiers
#define VIS_FLAG_MAGNIFIER          0.9
#define VIS_PERC_FLAG_MAGNIFIER		0.4
#define VIS_BALL_MAGNIFIER			0.9
#define VIS_PERC_BALL_MAGNIFIER		0.4
#define VIS_PLAYER_MAGNIFIER		1.5
#define VIS_PERC_PLAYER_MAGNIFIER	0.4
#define VIS_SPEED_MAGNIFIER			5.5
#define VIS_ACCEL_MAGNIFIER			5.5

#define PERCEPTION_COLOR_MODIFIER	0.85

enum EVisSetup
{
	VIS_SETUP_EMPTY    = 0x00000000,
	VIS_SETUP_PERCEPT  = 0x00000001,
	VIS_SETUP_BALL     = 0x00000002,
	VIS_SETUP_TEAMMATE = 0x00000004,
	VIS_SETUP_ENEMY    = 0x00000008,
	VIS_SETUP_PLAYER   = 0x00000010,
	VIS_SETUP_FULL     = 0xFFFFFFFF
};

/////////////////////////////////////////////////////////////////////
// Library header files
#include "types.h"
#include "visualsetupdlg.h"
#include "visualview.h"
#include "visualframe.h"

/////////////////////////////////////////////////////////////////////
// Global objects
extern CVisualView *gpVisualView;

#endif // _VIZUALIZE_MAIN_