// VisualSetupDlg.cpp : implementation file
//

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVisualSetupDlg dialog

CVisualSetupDlg::CVisualSetupDlg(
	EVisSetup &eVisSetup,
	CWnd* pParent /* = NULL*/
)
:	CDialog(CVisualSetupDlg::IDD, pParent),
	m_eVisSetup(eVisSetup)
{
	//{{AFX_DATA_INIT(CVisualSetupDlg)
	m_bPercept = (m_eVisSetup & VIS_SETUP_PERCEPT) != 0;
	m_bBall = (m_eVisSetup & VIS_SETUP_BALL) != 0;
	m_bTeammate = (m_eVisSetup & VIS_SETUP_TEAMMATE) != 0;
	m_bPlayer = (m_eVisSetup & VIS_SETUP_PLAYER) != 0;
	m_bOpponent = (m_eVisSetup & VIS_SETUP_ENEMY) != 0;
	//}}AFX_DATA_INIT
}

void CVisualSetupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CVisualSetupDlg)
	DDX_Check(pDX, IDC_CB_PERCEPTION_VIEW, m_bPercept);
	DDX_Check(pDX, IDC_CB_DRAW_BALL_INFO, m_bBall);
	DDX_Check(pDX, IDC_CB_DRAW_OPPONENT_INFO, m_bOpponent);
	DDX_Check(pDX, IDC_CB_DRAW_TEAMMATE_INFO, m_bTeammate);
	DDX_Check(pDX, IDC_CB_DRAW_AGENT_INFO, m_bPlayer);
	//}}AFX_DATA_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CVisualSetupDlg message handlers

BEGIN_MESSAGE_MAP(CVisualSetupDlg, CDialog)
	//{{AFX_MSG_MAP(CVisualSetupDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CVisualSetupDlg::OnOK() 
{
	UpdateData(TRUE);

	m_eVisSetup = (EVisSetup) (
		((m_bPercept) ? VIS_SETUP_PERCEPT : VIS_SETUP_EMPTY) |
		((m_bBall) ? VIS_SETUP_BALL : VIS_SETUP_EMPTY) |
		((m_bTeammate) ? VIS_SETUP_TEAMMATE : VIS_SETUP_EMPTY) |
		((m_bPlayer) ? VIS_SETUP_PLAYER : VIS_SETUP_EMPTY) |
		((m_bOpponent) ? VIS_SETUP_ENEMY : VIS_SETUP_EMPTY)
	);

	CDialog::OnOK();
}
