//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	C2DVector.cpp
 *  \brief Dvojrozmerneho vektora
 *  \author Mato Spal
 *  \date 19.3.2002 11:15:40
 *  \version 1.0
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//======================================================
// C2DVector : implementacia CQuery
//======================================================
string C2DVector::GetAttribute(const string &sName) const
{
	if(!IsValid())
		return string(QUERY_NOT_AVAILABLE);

	char sBuffer[QUERY_MAX_BUFFER] = QUERY_NOT_AVAILABLE;

	//-------------------------------------------------------
	// vektor po zlozkach
	//-------------------------------------------------------
	if(sName == "")
		sprintf(sBuffer, "%.2f %.2f", GetX(), GetY());

	//-------------------------------------------------------
	// size
	//-------------------------------------------------------
	else if(sName == "size")
		sprintf(sBuffer, "%.2f", GetDistance());

	//-------------------------------------------------------
	// angle
	//-------------------------------------------------------
	else if(sName == "angle")
		// uhly budu v jazyku pravidiel hraca v stupnoch
		sprintf(sBuffer, "%.2f", RadToDeg(GetAngle()));
	
	//-------------------------------------------------------
	// x
	//-------------------------------------------------------
	else if(sName == "x")
		sprintf(sBuffer, "%.2f", GetX());

	//-------------------------------------------------------
	// y
	//-------------------------------------------------------
	else if(sName == "y")
		sprintf(sBuffer, "%.2f", GetY());

	return string(sBuffer);
}

//======================================================
// CAngular2DVector : implementacia CQuery
//======================================================
string CAngular2DVector::GetAttribute(const string &sName) const
{
	if(!IsValid())
		return string(QUERY_NOT_AVAILABLE);

	char sBuffer[QUERY_MAX_BUFFER] = QUERY_NOT_AVAILABLE;

	//-------------------------------------------------------
	// vektor po zlozkach
	//-------------------------------------------------------
	if(sName == "")
		sprintf(sBuffer, "%.2f %.2f", GetX(), GetY());

	//-------------------------------------------------------
	// size
	//-------------------------------------------------------
	else if(sName == "size")
		sprintf(sBuffer, "%.2f", GetDistance());

	//-------------------------------------------------------
	// angle
	//-------------------------------------------------------
	else if(sName == "angle")
		// uhly budu v jazyku pravidiel hraca v stupnoch
		sprintf(sBuffer, "%.2f", RadToDeg(GetAngle()));
	
	//-------------------------------------------------------
	// x
	//-------------------------------------------------------
	else if(sName == "x")
		sprintf(sBuffer, "%.2f", GetX());

	//-------------------------------------------------------
	// y
	//-------------------------------------------------------
	else if(sName == "y")
		sprintf(sBuffer, "%.2f", GetY());

	return string(sBuffer);
}

