//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	Agent.h
 *  \brief Deklaracia triedy agenta modelu sveta
 *  \author Mato Spal
 *  \date 19.3.2002 10:53:01
 *  \version 1.0
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef _AGENT_
#define _AGENT_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CWorldModel;
class CAgent;

typedef vector<CAgent*> TAgentVector;
typedef TAgentVector::iterator TAgentVectorIterator;

class CAgent: public CMovingObject
{
	DECLARE_TERM_MAP

protected:
	CWorldModel &m_cWorld;

public:
	ESideType eSide;
	int iNumber;
	EViewQualityType eViewQuality;
	double dViewAngle;
	double dEffort;
	double dStamina;
	double dHeadDirection;
	double dBodyDirection;
    int iLastCatch;

public:
    CAgent(CWorldModel &cWorld);
	CAgent(const CAgent &cSource, CWorldModel &cWorld);

	double Similarity(
		const CSeenPlayer &cPlayer, 
		const CAgent &cThis
	);
	
	KPDL_RESULT Percept(
		const CSeenPlayer &cPlayer, 
		const CAgent &cThis
	);

	const CAngular2DVector RelVectorTo(const C2DVector cPos)
	{
		//! mozno by sa malo otacat o dBodyDirection
		//  zatial voci hlave - relativna poloha, na ktorej
		//  hrac vidi objekt
		return Rot(cPos - cPosition, -dHeadDirection);

		//return Rot(cPos - cPosition, dBodyDirection);
	}

	// termy
	string SightingBall();
	string HasBall();
	string BallKickable();
	string BallNear();
	string BallInterceptPosition();
	string NearGoal();
	string FreePathToGoal();
	string HasFreeTeamMate();
	string HasBetterLocatedTeamMate();
	string TeamMateHasBall();
	string TeamMateNearBall();
	string CanPass();
	string CanGetPass();
	string LocationForPass();
	string BestLocatedTeamMate();
	string IsFree();
	string FreePosition();

	// implementacia rozhrania CQuery
	string GetAttribute(const string &sName);

	CAgent &operator =(const CAgent &cSource);

};

#endif // _AGENT_
