//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	MovingObject.h
 *  \brief Deklaracia triedy pohybujuceho sa objektu v modeli sveta
 *  \author Mato Spal
 *  \date 19.3.2002 10:41:30
 *  \version 1.0
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef _MOVING_OBJECT_
#define _MOVING_OBJECT_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CAgent;

class CMovingObject : public CQuery
{
//Members
private:
	// parametre objektu ovplyvnujuce jeho spravanie
	double m_dMaxAcceleration;
	double m_dMaxSpeed;
	double m_dSpeedDecay;

public:
	// pozicia objektu v predchadzajucom kroku
	C2DVector cPrevPosition;
	// aktualne parametre objektu
	C2DVector cPosition;
	C2DVector cSpeed;
	C2DVector cAcceleration;
	// pocet cyklov od posledneho zhliadnutia objektu
	int iLastSeen;

// Methods
public:
	CMovingObject(
		const double dMaxAcceleration,
		const double dMaxSpeed,
		const double dSpeedDecay
	);
	CMovingObject(const CMovingObject& cSource);

	virtual ~CMovingObject() {}

	virtual KPDL_RESULT Precompute();
	virtual KPDL_RESULT Percept(
		const CSeenObject &cObject, 
		const CAgent &cThis
	);

    bool IsValid() const
	{
		return (iLastSeen < WORLD_MAX_LAST_SEEN);
	}

	// rozhranie CQuery
	string GetAttribute(const string &sName);

	CMovingObject &operator =(const CMovingObject &cSource);

};

#endif // _MOVING_OBJECT_
