// StaticField.h: interface for the CStaticField class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _STATIC_FIELD_
#define _STATIC_FIELD_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CStaticField  
{
// Members
public:
	// rozmery ihriska
	double dFieldLength;
	double dFieldWidth;
	// rozmery penaltovej oblasti
	double dPenaltyLength;
	double dPenaltyWidth;
	// rozmer branky
	double dGoalSize;
	// rozmer fyzickeho okraja ihriska
	double dBoundary;

protected:
	T2DVectorVector m_cFlags;
	T2DVectorVector m_cGoals;
	T2DLineVector m_cLines;

public:
	CStaticField(
		const double dFieldLength,
		const double dFieldWidth, 
		const double dPenaltyLength,
		const double dPenaltyWidth,
		const double dGoalWidth,
		const double dBoundary
	);
	virtual ~CStaticField();

	const C2DVector GetFlag(const EFlagType eFlag)
	{ 
		return m_cFlags[eFlag];
	}
	
	const C2DVector GetGoal(const EGoalType eGoal)
	{ 
		return m_cGoals[eGoal]; 
	}
	
	const C2DLine GetLine(const ELineType eLine)
	{ 
		return m_cLines[eLine];
	}

	KPDL_RESULT CreateFlags();
	KPDL_RESULT CreateGoals();
	KPDL_RESULT CreateLines();
};

#endif // _STATIC_FIELD_
