//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	WorldMain.h
 *  \brief Hlavny hlavickovy subor "modulu modela sveta"
 *  \author Mato Spal
 *  \date 12.3.2002 21:36:54
 *  \version 1.0
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef _WORLD_MAIN_
#define _WORLD_MAIN_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#pragma warning (disable : 4786)

/////////////////////////////////////////////////////////////////////
// External libraries
#include "parsermain.h"
#include "eventmain.h"
#include "communicationmain.h"

/////////////////////////////////////////////////////////////////////
// Platform dependent header
#define VC_EXTRALEAN
#include <afx.h>
#include <afxcmn.h>

/////////////////////////////////////////////////////////////////////
// Standard header files
#include <math.h>
#include <string>
#include <vector>
#include <queue>
#include <algorithm>
#include <map>

using namespace std;

/////////////////////////////////////////////////////////////////////
// Library settings
#define	WORLD_MAX_LAST_SEEN         20     // cyklov
#define WORLD_MAX_BALL_CONTROL_DIST 5      // krokov
#define WORLD_MAX_BALL_DIST         50.0   // metrov
#define WORLD_MAX_OPPONENT_DIST     10.0   // metrov

/////////////////////////////////////////////////////////////////////
// Library header files
#include "types.h"
#include "config.h"
#include "2dvector.h"
#include "2dline.h"
#include "rectangle.h"
#include "movingobject.h"
#include "agent.h"
#include "staticfield.h"
#include "worldmodel.h"
#include "SeeEvent.h"
#include "SenseBodyevent.h"
#include "InitEvent.h"
#include "HearEvent.h"
#include "decideevent.h"
#include "worldthread.h"

#include "visualizemain.h"
/////////////////////////////////////////////////////////////////////
// Global objects

#endif // _WORLD_MAIN_
