//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	WorldModel.h
 *  \brief Deklaracia triedy modelu sveta
 *  \author Mato Spal
 *  \date 19.3.2002 11:27:26
 *  \version 1.0
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef _WORLD_MODEL_
#define _WORLD_MODEL_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CWorldModel : public CQuery
{
	DECLARE_TERM_MAP

public:
	CGameTime cTime;
	CStaticField &cField;
	CMovingObject cBall;
	TAgentVector cIdentifiedAgents;
	TAgentVector cUnIdentifiedAgents;
	CAgent cThis;
	CHearMsg cHear;

public:
	CWorldModel(CStaticField &cField);
	CWorldModel(CWorldModel& cSource);
	~CWorldModel();

	void ClearCache();

	KPDL_RESULT Recompute(CSeeMsg &cSeeMsg);
	KPDL_RESULT Precompute();

	KPDL_RESULT ProcessSenseBody(CSenseBody &cSenseBody);
	KPDL_RESULT ProcessInit(CInitMsg &cInitMsg);
	KPDL_RESULT ProcessHear(CHearMsg &cHearMsg);

	KPDL_RESULT UpdatePlayerPosition(
		TSeenFlagVector &cFlags, 
		TSeenGoalVector &cGoals, 
		TSeenLineVector &cLines
	);

	// Termy
	string SomeoneHasBall();
	string OpponentGoal();
	string IsPassMessage();

	// Query
	string GetAttribute(const string &sName);

	CWorldModel &operator =(CWorldModel& cSource);

};

#endif // _WORLD_MODEL_
