// Worldthread.cpp: implementation of the CWorldThread class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

BEGIN_EVENT_MAP(CWorldThread)
	ADD_EVENT(E_See, CWorldThread::OnSee)
	ADD_EVENT(E_SenseBody, CWorldThread::OnSenseBody)
	ADD_EVENT(E_Init, CWorldThread::OnInit)
	ADD_EVENT(E_Hear, CWorldThread::OnHear)
END_EVENT_MAP

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CWorldThread::CWorldThread(CCoordinator &cCoordinator, CStaticField &cField)
:	CEventThread(cCoordinator, THREAD_PRIORITY_NORMAL),
	cWorld(cField)
{
}

KPDL_RESULT CWorldThread::OnSee(CEvent &cEvent)
{    
	CSeeEvent &cSeeEvent = (CSeeEvent &)cEvent;

	cWorld.Recompute(*cSeeEvent.pSeeMsg); 
	
	if(gpVisualView != NULL)
	{
		gpVisualView->cSeeMsg = *cSeeEvent.pSeeMsg;
		gpVisualView->Invalidate();
	}

	return KPDL_SUCCESS;
}

KPDL_RESULT CWorldThread::OnSenseBody(CEvent &cEvent)
{    
	CSenseBodyEvent &cSenseBodyEvent = (CSenseBodyEvent &)cEvent;

	cWorld.ProcessSenseBody(*cSenseBodyEvent.pSenseBodyMsg);

	CEvent *pEvent = new CDecideEvent(cWorld); 
	GenerateEvent(pEvent);
	pEvent->Release();

	return KPDL_SUCCESS;
}

KPDL_RESULT CWorldThread::OnInit(CEvent &cEvent)
{    
	CInitEvent &cInitEvent = (CInitEvent &)cEvent;

	cWorld.ProcessInit(*cInitEvent.pInitMsg);

	return KPDL_SUCCESS;
}

KPDL_RESULT CWorldThread::OnHear(CEvent &cEvent)
{    
	CHearEvent &cHearEvent = (CHearEvent &)cEvent;

	cWorld.ProcessHear(*cHearEvent.pHearMsg);

	return KPDL_SUCCESS;
}
